# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`ora_install`](#ora_install): ora_install   See the file "LICENSE" for the full license governing this code.
* [`ora_install::clear_caches`](#ora_installclear_caches): This class contains the puppet code that implements the default facter cache invainvalidationlidatin rules.
* [`ora_install::fact_caching`](#ora_installfact_caching): This class ensure's that the ora_install facts that can be cached and are cached with the correct settings.
* [`ora_install::prepareautostart`](#ora_installprepareautostart): Prepare autostart of the database for linux.

### Defined types

* [`ora_install::autostartdatabase`](#ora_installautostartdatabase): This defined type create's a startup script for the specified database and enables the service.
* [`ora_install::client`](#ora_installclient): Installs the Oracle client software.
* [`ora_install::database`](#ora_installdatabase): This defined type allows you to create or delete a database.
* [`ora_install::database_pluggable`](#ora_installdatabase_pluggable): Creates or delete a pluggable database.
* [`ora_install::dbactions`](#ora_installdbactions): Defined type to start and stop a database.
* [`ora_install::goldengate`](#ora_installgoldengate): Installs the Oracle goldengate software.
* [`ora_install::installasm`](#ora_installinstallasm): Installs and configures Oracle grid.
* [`ora_install::installdb`](#ora_installinstalldb): You can use this class to install a working oracle database on your system.
* [`ora_install::installem`](#ora_installinstallem): Installs the Oracle Enterprse Manager.
* [`ora_install::installem_agent`](#ora_installinstallem_agent): Installs the Oracle Enterprise Manager Agent.
* [`ora_install::net`](#ora_installnet): Installs and configures Oracle SQL*Net
* [`ora_install::opatchupgrade`](#ora_installopatchupgrade): Installs or upgrades the specified version of the Oracle OPatch utility.
* [`ora_install::prepareautostart_for`](#ora_installprepareautostart_for): Prepare autostart of the database for linux.
* [`ora_install::rcu`](#ora_installrcu): Install the repository for several Oracle Fusion products.
* [`ora_install::tnsnames`](#ora_installtnsnames): Manages an entry in a `tnsnames.
* [`ora_install::utils::dborainst`](#ora_installutilsdborainst): Internal utility to create the required Oracle directories.

### Resource types

* [`db_control`](#db_control): control the database instance state like running,stop,restart
* [`db_directory_structure`](#db_directory_structure): add all the directories needed by the oracle db or asm installation
* [`db_listener`](#db_listener): control the oracle db listener state like running,stop,restart
* [`db_opatch`](#db_opatch): This is the Oracle Patch process called OPatch
* [`db_rcu`](#db_rcu): This is the Oracle RCU ( Repository creation utility) installer type
* [`ora_home`](#ora_home): This resource allows you to manage Oracle homes.
* [`ora_install`](#ora_install): Start the setup for applying ora_install classes.
* [`ora_opatch`](#ora_opatch): This resource allows you to manage opatch patches on a specific database home.
* [`ora_tab_entry`](#ora_tab_entry): With this type you can manage entries in the systems oratab file.  Here is an example on how to use this:    ora_tab_entry { 'MYDB':       en

### Functions

* [`opatch_version`](#opatch_version): See the file "LICENSE" for the full license governing this code.  Returns the the installed Opatch version for a specfied Oracle home
* [`ora_install::changed_oracle_home_for`](#ora_installchanged_oracle_home_for): See the file "LICENSE" for the full license governing this code.   This function checks if the specified home, is the current home for the sp
* [`ora_install::opatch_version`](#ora_installopatch_version): See the file "LICENSE" for the full license governing this code.  Returns the the installed Opatch version for a specfied Oracle home
* [`ora_install::ora_patches_installed`](#ora_installora_patches_installed): See the file "LICENSE" for the full license governing this code.   This function checks if the specfied patches are installed. The patch list
* [`ora_install::ora_patches_missing`](#ora_installora_patches_missing): See the file "LICENSE" for the full license governing this code.   This function checks if the specfied patches are installed. For type = db 
* [`ora_install::ora_physical_patches`](#ora_installora_physical_patches): See the file "LICENSE" for the full license governing this code.   This function parses a Hash of patches and looks for resources with sub_pa
* [`ora_install::oracle_exists`](#ora_installoracle_exists)
* [`ora_patches_installed`](#ora_patches_installed): See the file "LICENSE" for the full license governing this code.   This function checks if the specfied patches are installed. The patch list
* [`ora_physical_patches`](#ora_physical_patches): See the file "LICENSE" for the full license governing this code.   This function parses a Hash of patches and looks for resources with sub_pa
* [`oracle_exists`](#oracle_exists)

### Data types

* [`Ora_install::DatabaseVersion`](#ora_installdatabaseversion)
* [`Ora_install::ShortVersion`](#ora_installshortversion)
* [`Ora_install::Version`](#ora_installversion)

### Tasks

* [`agent_action`](#agent_action): Enable, disable or start a puppet agent run.
* [`apply_psu_db`](#apply_psu_db): Execute the PSU database update for specified SID.
* [`db_action`](#db_action): Execute an action pn the specified Oracle instance
* [`grid_action`](#grid_action): Execute actions (stop/start) on Oracle Grid installations for patching.
* [`listener_action`](#listener_action): Execute an action on the Oracle listener
* [`opatch_upgrade`](#opatch_upgrade): Apply patch(es) to an Oracle home.
* [`restart`](#restart): Restart the specified Oracle instance on the specified node
* [`shutdown`](#shutdown): Shutdown the specified Oracle instance on the specified node
* [`startup`](#startup): Startup the specified Oracle instance on the specified node
* [`switch_grid_home`](#switch_grid_home): Switch a running instance to an other already available Oracle home.
* [`switch_oracle_home`](#switch_oracle_home): Switch a running instance to an other already available Oracle home.
* [`upgrade_db`](#upgrade_db): Execute the database upgrade for specified SID.

### Plans

* [`ora_install::install_grid_home_and_patch`](#ora_installinstall_grid_home_and_patch): This plan will install a new GRID_HOME and apply the specified patches to it.
* [`ora_install::install_oracle_home`](#ora_installinstall_oracle_home): This plan will install a new ORACLE_HOME.
* [`ora_install::install_oracle_home_and_patch`](#ora_installinstall_oracle_home_and_patch): This plan will install a new ORACLE_HOME and apply the specified patches to it.
* [`ora_install::opatch_upgrade`](#ora_installopatch_upgrade): This plan will install a new version of OPatch in specified ORACLE_HOME.
* [`ora_install::patch_home`](#ora_installpatch_home): This plan will install patches into specified home.
* [`ora_install::switch_home_and_apply_psu`](#ora_installswitch_home_and_apply_psu): This plan will switch an Oracle database to an already existing other ORACLE_HOME and apply the patches in the database.
* [`ora_install::switch_home_asm`](#ora_installswitch_home_asm): This plan will switch an Grid Infrastructure installation to an already existing other GRID_HOME.

## Classes

### <a name="ora_install"></a>`ora_install`

ora_install


See the file "LICENSE" for the full license governing this code.

### <a name="ora_installclear_caches"></a>`ora_install::clear_caches`

ora_install::clear_caches

Whenever a certain set of Puppet classes or defined types is applied, it will clear the facter caches for those facts that are implemented.


See the file "LICENSE" for the full license governing this code.

### <a name="ora_installfact_caching"></a>`ora_install::fact_caching`

ora_install::fact_caching

You can change all TTL settings for the facts if an other setting is more fitting for your setup.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `ora_install::fact_caching` class:

* [`enabled`](#enabled)
* [`product_version_ttl`](#product_version_ttl)
* [`opatch_version_ttl`](#opatch_version_ttl)
* [`installed_patches_ttl`](#installed_patches_ttl)
* [`running_processes_ttl`](#running_processes_ttl)
* [`defined_sids_ttl`](#defined_sids_ttl)
* [`ora_install_inventory_loc_ttl`](#ora_install_inventory_loc_ttl)

##### <a name="enabled"></a>`enabled`

Data type: `Boolean`

When set to true, this enables facter caching for the ora_install module facts.
Beware that you need to have Facter version 4.1.0 or higher to enabled this. When you set this value to true, automatically TTL settings for most of the ora_install facts are set to a default value. For most installations, the default settings are fine.
When you set this value to `true`, the [facter setting `force-dot-resolution`](https://tickets.puppetlabs.com/browse/PUP-11089) is enabled. You have to ensure that all of your facts keep on working with this setting.

##### <a name="product_version_ttl"></a>`product_version_ttl`

Data type: `Optional[String[1]]`

The Time to Live for the `ora_install_homes.
product_version` part of the `ora_install_homes` fact.

##### <a name="opatch_version_ttl"></a>`opatch_version_ttl`

Data type: `Optional[String[1]]`

The Time to Live for the `ora_install_homes.
opatch_version` part of the `ora_install_homes` fact.

##### <a name="installed_patches_ttl"></a>`installed_patches_ttl`

Data type: `Optional[String[1]]`

The Time to Live for the `ora_install_homes.
installed_patches` part of the `ora_install_homes` fact.

##### <a name="running_processes_ttl"></a>`running_processes_ttl`

Data type: `Optional[String[1]]`

The Time to Live for the `ora_install_homes.
running_processes` part of the `ora_install_homes` fact.

##### <a name="defined_sids_ttl"></a>`defined_sids_ttl`

Data type: `Optional[String[1]]`

The Time to Live for the `ora_install_homes.
defined_sids` part of the `ora_install_homes` fact.

##### <a name="ora_install_inventory_loc_ttl"></a>`ora_install_inventory_loc_ttl`

Data type: `Optional[String[1]]`

The Time to Live for the `ora_install_inventory_loc` fact.

### <a name="ora_installprepareautostart"></a>`ora_install::prepareautostart`

ora_install::prepareautostart

This class creates the script needed to start the database after a system reboot. It supports both `systemd` and the older startup scripts.

Here is an example on how to use it:

```puppet
  class { 'class ora_install::prepareautostart':
    oracle_home  => '/oracle/db1',
    user         => 'oracle',
    service_name => 'start_db1',
  }
```
This class is a conveneance class around the defined type `prepareautostart_for`.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `ora_install::prepareautostart` class:

* [`oracle_home`](#oracle_home)
* [`user`](#user)
* [`service_name`](#service_name)
* [`logoutput`](#logoutput)

##### <a name="oracle_home"></a>`oracle_home`

Data type: `Stdlib::Absolutepath`

A directory to be used as Oracle home directory for this software.

Default value: ``undef``

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.
The install class will not create the user for you. You must do that yourself.
The default value is: `oracle`

Default value: `'oracle'`

##### <a name="service_name"></a>`service_name`

Data type: `String[1]`

The name of the init service to use.
The default value is: `dbora`

Default value: `'dbora'`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Boolean,Enum['on_failure']]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup( { name => 'logoutput', default_value => 'on_failure' })`

## Defined types

### <a name="ora_installautostartdatabase"></a>`ora_install::autostartdatabase`

ora_install::autostartdatabase

The end result is that the named Oracle database is
restarted after a system restart.

Here is an example on how to use it:

``` puppet
ora_install::autostartdatabase{ 'autostart oracle':
  oracle_home             => '/oracle/product/12.1/db',
  user                    => 'oracle',
  db_name                 => 'test',
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `ora_install::autostartdatabase` defined type:

* [`db_domain`](#db_domain)
* [`db_name`](#db_name)
* [`db_policy`](#db_policy)
* [`db_type`](#db_type)
* [`group`](#group)
* [`limits`](#limits)
* [`logoutput`](#logoutput)
* [`oracle_home`](#oracle_home)
* [`service_name`](#service_name)
* [`start_option`](#start_option)
* [`systemd_template`](#systemd_template)
* [`systemd_template_vars`](#systemd_template_vars)
* [`user`](#user)

##### <a name="db_domain"></a>`db_domain`

Data type: `Optional[String[1]]`

The domain of the database.

Default value: ``undef``

##### <a name="db_name"></a>`db_name`

Data type: `String[1]`

The name of the database.

Default value: ``undef``

##### <a name="db_policy"></a>`db_policy`

Data type: `Enum['AUTOMATIC','MANUAL','NORESTART']`

The srvctl management policy for the database
Valid values are:
- `AUTOMATIC`
- `MANUAL`
- `NORESTART`
The default value is: `AUTOMATIC`

Default value: `'AUTOMATIC'`

##### <a name="db_type"></a>`db_type`

Data type: `Enum['database','grid']`

The type of the database used to specify if the database should be started by an init script or srvctl.
Valid values are:
- `grid`
- `database`
The default value is: 'database'

Default value: `'database'`

##### <a name="group"></a>`group`

Data type: `String[1]`

The os group to use for these Oracle puppet definitions.
The default value is: `dba`

Default value: `'dba'`

##### <a name="limits"></a>`limits`

Data type: `Optional[Hash]`

The limits for the systemd service.
The default value is: undef
Below is an axample. Currently only the 'hard' values are used.
```yaml
ora_install::autostartdatabase::limits:
  '*/nofile':
    soft: 2048
    hard: 8192
  'oracle/nofile':
    soft: 65536
    hard: 65536
  'oracle/nproc':
    soft: 2048
    hard: 16384
  'oracle/stack':
    soft: 10240
    hard: 32768
```

Default value: ``undef``

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Boolean,Enum['on_failure']]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup( { name => 'logoutput', default_value => 'on_failure' })`

##### <a name="oracle_home"></a>`oracle_home`

Data type: `Stdlib::Absolutepath`

A directory to be used as Oracle home directory for this software.

Default value: ``undef``

##### <a name="service_name"></a>`service_name`

Data type: `String[1]`

The service name to start.

Default value: `'dbora'`

##### <a name="start_option"></a>`start_option`

Data type: `Enum['OPEN','MOUNT','READ ONLY']`

The srvctl startup options for the database.
Valid values are:
- `OPEN`
- `MOUNT`
- `READ ONLY`
The default value is: `OPEN`

Default value: `'OPEN'`

##### <a name="systemd_template"></a>`systemd_template`

Data type: `Optional[String[1]]`

Use custom EPP template for systemd service
The default value is: undef

Default value: ``undef``

##### <a name="systemd_template_vars"></a>`systemd_template_vars`

Data type: `Optional[Hash]`

The variables to use when specifying a custom EPP template for systemd service
The default value is: undef

Default value: ``undef``

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.
The install class will not create the user for you. You must do that yourself.
The default value is: `oracle`

Default value: `'oracle'`

### <a name="ora_installclient"></a>`ora_install::client`

ora_install::client

Using this defined type you can install the Oracle client software on your system.

Here is an example on how to use it:

```puppet
ora_install::client{ '12.1.0.1_Linux-x86-64':
  version                   => '12.1.0.1',
  file                      => 'linuxamd64_12c_client.zip',
  oracle_base               => '/oracle',
  oracle_home               => '/oracle/product/12.1/client',
  user                      => 'oracle',
  group                     => 'dba',
  group_install             => 'oinstall',
  download_dir              => '/install',
  bash_profile              => true,
  puppet_download_mnt_point => "puppet:///modules/ora_install/",
  ora_inventory_dir         => '/oracle/product',
  logoutput                 => true,
}
```

### support for multiple versions

This defined type has support for installing different versions of the client software on your system. In order to do this use the defined type multiple times in you manifest and use a different `oracle_home` and a different `file`.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `ora_install::client` defined type:

* [`bash_profile`](#bash_profile)
* [`db_port`](#db_port)
* [`download_dir`](#download_dir)
* [`file`](#file)
* [`group`](#group)
* [`group_install`](#group_install)
* [`logoutput`](#logoutput)
* [`ora_inventory_dir`](#ora_inventory_dir)
* [`oracle_base`](#oracle_base)
* [`oracle_home`](#oracle_home)
* [`puppet_download_mnt_point`](#puppet_download_mnt_point)
* [`temp_dir`](#temp_dir)
* [`umask`](#umask)
* [`user`](#user)
* [`user_base_dir`](#user_base_dir)
* [`version`](#version)
* [`allow_insecure`](#allow_insecure)
* [`install_type`](#install_type)
* [`install_options`](#install_options)
* [`architecture`](#architecture)

##### <a name="bash_profile"></a>`bash_profile`

Data type: `Boolean`

Create a bash profile for the specified user or not.
Valid values are `true` and `false`.
When you specify a `true` for the parameter, Puppet will create a standard bash profile for the specified user. The bash profile will be placed in a directory named `user_base_dir/user`.
```puppet
ora_install::client { 'Oracle client':
  ...
  bash_profile  => true,
  user          => 'oracle',
  user_base_dir => '/home',
  ...
}
```
This snippet will create a bash profile called `/home/oracle/.bash_profile`.

Default value: ``true``

##### <a name="db_port"></a>`db_port`

Data type: `Integer`

The IP port to use for database communication.
The default value is: `1521`

Default value: `1521`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `'/install'`

##### <a name="file"></a>`file`

Data type: `String[1]`

The source file to use.

Default value: ``undef``

##### <a name="group"></a>`group`

Data type: `String[1]`

The os group to use for these Oracle puppet definitions.
The default value is: `dba`

Default value: `'dba'`

##### <a name="group_install"></a>`group_install`

Data type: `String[1]`

The os group to use for installation.
The default value is: `oinstall`

Default value: `'oinstall'`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Boolean,Enum['on_failure']]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup( { name => 'logoutput', default_value => 'on_failure' })`

##### <a name="ora_inventory_dir"></a>`ora_inventory_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The directory that contains the oracle inventory.
The default value is: `/oracle_base/oraInventory`

Default value: ``undef``

##### <a name="oracle_base"></a>`oracle_base`

Data type: `Stdlib::Absolutepath`

A directory to use as Oracle base directory.

Default value: ``undef``

##### <a name="oracle_home"></a>`oracle_home`

Data type: `Stdlib::Absolutepath`

A directory to be used as Oracle home directory for this software.

Default value: ``undef``

##### <a name="puppet_download_mnt_point"></a>`puppet_download_mnt_point`

Data type: `Optional[String[1]]`

The base path of all remote files for the defined type or class.
The default value is: `puppet:///modules/ora_install`

Default value: ``undef``

##### <a name="temp_dir"></a>`temp_dir`

Data type: `Stdlib::Absolutepath`

Directory to use for temporary files.

Default value: `'/tmp'`

##### <a name="umask"></a>`umask`

Data type: `String[1]`

The umask to use for commands that run in the context of either the grid user or the oracle user.
The default is `0022`

Default value: `'0022'`

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.
The install class will not create the user for you. You must do that yourself.
The default value is: `oracle`

Default value: `'oracle'`

##### <a name="user_base_dir"></a>`user_base_dir`

Data type: `Stdlib::Absolutepath`

The directory to use as base directory for the users.

Default value: `'/home'`

##### <a name="version"></a>`version`

Data type: `Ora_install::Version`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: ``undef``

##### <a name="allow_insecure"></a>`allow_insecure`

Data type: `Boolean`

When set to `true` Ignore HTTPS certificate errors
(default: false)

Default value: `lookup( { name => 'allow_insecure', default_value => false })`

##### <a name="install_type"></a>`install_type`

Data type: `Enum['Administrator','Runtime','InstantClient','Custom']`

Installation type of the Oracle client.
The following choices are available. The value should contain only one of these choices:
    - Administrator
    - Runtime
    - InstantClient
    - Custom
The default is administrator.

Default value: `'Administrator'`

##### <a name="install_options"></a>`install_options`

Data type: `Array[String]`

The list of Client Components you would like to install.
This property is considered only if INSTALL_TYPE is set to "Custom"

The following choices are available. You may specify any
combination of these choices.  The components you choose should
be specified in the form "internal-component-name:version"
Below is a list of components you may specify to install for Oracle 21.
- oracle.sqlj:21.0.0.0.0 -- "Oracle SQLJ"
- oracle.rdbms.util:21.0.0.0.0 -- "Oracle Database Utilities"
- oracle.javavm.client:21.0.0.0.0 -- "Oracle Java Client"
- oracle.sqlplus:21.0.0.0.0 -- "SQL*Plus"
- oracle.dbjava.jdbc:21.0.0.0.0 -- "Oracle JDBC/THIN Interfaces"
- oracle.ldap.client:21.0.0.0.0 -- "Oracle Internet Directory Client"
- oracle.rdbms.oci:21.0.0.0.0 -- "Oracle Call Interface (OCI)"
- oracle.precomp:21.0.0.0.0 -- "Oracle Programmer"
- oracle.xdk:21.0.0.0.0 -- "Oracle XML Development Kit"
- oracle.network.aso:21.0.0.0.0 -- "Oracle Advanced Security"
- oracle.oraolap.mgmt:21.0.0.0.0 -- "OLAP Analytic Workspace Manager and Worksheet"
- oracle.network.client:21.0.0.0.0 -- "Oracle Net"
- oracle.network.cman:21.0.0.0.0 -- "Oracle Connection Manager"
- oracle.network.listener:21.0.0.0.0 -- "Oracle Net Listener"
- oracle.ordim.client:21.0.0.0.0 -- "Oracle Multimedia Client Option"
- oracle.odbc:21.0.0.0.0 -- "Oracle ODBC Driver"
- oracle.dbdev:21.0.0.0.0 -- "Oracle SQL Developer"
- oracle.rdbms.scheduler:21.0.0.0.0 -- "Oracle Scheduler Agent"
- oracle.rdbms.drdaas:21.0.0.0.0  -- "Oracle Database Provider for DRDA"

Default value: `[]`

##### <a name="architecture"></a>`architecture`

Data type: `Enum['client32','client']`

The type of architecture client you want to install.
This **MUST** match the file you are provinding to the installed. Valid values are:
- `client`
- `client32`
The default is `client`

Default value: `'client'`

### <a name="ora_installdatabase"></a>`ora_install::database`

ora_install::database

Under the hood the calls the `dbca` utility to do the work. When you need more control over the individual settings when creating the database, you must use the [`ora_database` custom type of the `ora_config` module](https://www.enterprisemodules.com/docs/ora_config/ora_database.html)

Here is an example on how to use this defined type to create a database:

```puppet
ora_install::database{ 'testDb_Create':
  action                    => 'create',
  oracle_base               => '/oracle',
  oracle_home               => '/oracle/product/11.2/db',
  version                   => '11.2',
  user                      => 'oracle',
  group                     => 'dba',
  download_dir              => '/install',
  action                    => 'create',
  db_name                   => 'test',
  db_domain                 => 'oracle.com',
  db_port                   => '1521',
  sys_password              => 'Welcome01',
  system_password           => 'Welcome01',
  data_file_destination     => "/oracle/oradata",
  recovery_area_destination => "/oracle/flash_recovery_area",
  character_set             => "AL32UTF8",
  nationalcharacter_set     => "UTF8",
  init_params               => {'open_cursors'        => '1000',
                                'processes'           => '600',
                                'job_queue_processes' => '4' },
  sample_schema             => 'TRUE',
  memory_percentage         => "40",
  memory_total              => "800",
  database_type             => "MULTIPURPOSE",
  em_configuration          => "NONE",
  require                   => Ora_install::Listener['start listener'],
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `ora_install::database` defined type:

* [`action`](#action)
* [`asm_diskgroup`](#asm_diskgroup)
* [`asm_snmp_password`](#asm_snmp_password)
* [`character_set`](#character_set)
* [`cluster_nodes`](#cluster_nodes)
* [`container_database`](#container_database)
* [`data_file_destination`](#data_file_destination)
* [`database_type`](#database_type)
* [`db_conf_type`](#db_conf_type)
* [`db_domain`](#db_domain)
* [`db_name`](#db_name)
* [`db_port`](#db_port)
* [`db_snmp_password`](#db_snmp_password)
* [`download_dir`](#download_dir)
* [`em_configuration`](#em_configuration)
* [`group`](#group)
* [`init_params`](#init_params)
* [`logoutput`](#logoutput)
* [`memory_percentage`](#memory_percentage)
* [`memory_total`](#memory_total)
* [`nationalcharacter_set`](#nationalcharacter_set)
* [`oracle_base`](#oracle_base)
* [`oracle_home`](#oracle_home)
* [`puppet_download_mnt_point`](#puppet_download_mnt_point)
* [`recovery_area_destination`](#recovery_area_destination)
* [`recovery_diskgroup`](#recovery_diskgroup)
* [`sample_schema`](#sample_schema)
* [`storage_type`](#storage_type)
* [`sys_password`](#sys_password)
* [`system_password`](#system_password)
* [`template`](#template)
* [`template_type`](#template_type)
* [`user`](#user)
* [`memory_mgmt_type`](#memory_mgmt_type)
* [`version`](#version)

##### <a name="action"></a>`action`

Data type: `Enum['create','delete']`

The action that must be taken.
create or delete.
Valid values are:
- `create`
- `delete`
The default value is: `create`

Default value: `'create'`

##### <a name="asm_diskgroup"></a>`asm_diskgroup`

Data type: `String[1]`

The ASM diskgroup to use for the database.
The default value is: `DATA`

Default value: `'DATA'`

##### <a name="asm_snmp_password"></a>`asm_snmp_password`

Data type: `Optional[Easy_type::Password]`

The password to use for the ASMSNMP user.

Default value: ``undef``

##### <a name="character_set"></a>`character_set`

Data type: `String[1]`

The character set to use for running the database.
The default value is: `AL32UTF8`

Default value: `'AL32UTF8'`

##### <a name="cluster_nodes"></a>`cluster_nodes`

Data type: `Optional[String[1]]`

A comma seperated list of the nodes running in the RAC cluster.
Example: `node1,node2`

Default value: ``undef``

##### <a name="container_database"></a>`container_database`

Data type: `Boolean`

Database is a container for pluggable databases.
When you want to add pluggable database to this database, specify a value of `true`.
The default value is: `false`

Default value: ``false``

##### <a name="data_file_destination"></a>`data_file_destination`

Data type: `Optional[String[1]]`

The location of the data file's.

Default value: ``undef``

##### <a name="database_type"></a>`database_type`

Data type: `Enum['MULTIPURPOSE','DATA_WAREHOUSING','OLTP']`

The kind of database you want to create.
Valid values are:
- `MULTIPURPOSE`
- `DATA_WAREHOUSING`
- `OLTP`
The default value is: `MULTIPURPOSE`

Default value: `'MULTIPURPOSE'`

##### <a name="db_conf_type"></a>`db_conf_type`

Data type: `Enum['SINGLE','RAC','RACONE']`

The type of database that needs to be installed.
Valid values are:
- `SINGLE`
- `RAC`
- `RACONE`

Default value: `'SINGLE'`

##### <a name="db_domain"></a>`db_domain`

Data type: `Optional[String[1]]`

The domain of the database.

Default value: ``undef``

##### <a name="db_name"></a>`db_name`

Data type: `String[1]`

The name of the database.

Default value: `'orcl'`

##### <a name="db_port"></a>`db_port`

Data type: `Integer`

The IP port to use for the database.
The default value is: `1521`

Default value: `1521`

##### <a name="db_snmp_password"></a>`db_snmp_password`

Data type: `Optional[Easy_type::Password]`

Password to use for the dbsnmp user.

Default value: ``undef``

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `'/install'`

##### <a name="em_configuration"></a>`em_configuration`

Data type: `Enum['CENTRAL','LOCAL','ALL','NONE','DBEXPRESS','BOTH']`

The type of Enterprise Manager configuration.
Valid values are:
- `CENTRAL`   (all versions)
- `LOCAL`     (version < 12.2)
- `ALL`       (version < 12.2)
- `NONE`      (all versions)
- `DBEXPRESS` (version >= 12.2)
- `BOTH`      (version >= 12.2)
The default value is: `NONE`

Default value: `'NONE'`

##### <a name="group"></a>`group`

Data type: `String[1]`

The os group to use for these Oracle puppet definitions.
The default value is: `dba`

Default value: `'dba'`

##### <a name="init_params"></a>`init_params`

Data type: `Optional[Variant[String[1], Hash]]`

The init parameters to use for the database.
You can use either a comma separated string for init_params or a Hash.
### Using comma separated string
Here is an example using a comma separated string:
``` puppet
ora_install::database{'my_database'
  ...
  init_params => "open_cursors=1000,processes=600,job_queue_processes=4",
  ...
}
```
### Using a Hash
Here is an example using a Hash:
``` puppet
ora_install::database{'my_database'
  ...
  init_params  => {'open_cursors'        => '1000',
                  'processes'           => '600',
                  'job_queue_processes' => '4' },
  }
  ...
}
```

Default value: ``undef``

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Boolean,Enum['on_failure']]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup( { name => 'logoutput', default_value => 'on_failure' })`

##### <a name="memory_percentage"></a>`memory_percentage`

Data type: `Integer`

The percentage of physical memory for Oracle.
The default value is: `40`

Default value: `40`

##### <a name="memory_total"></a>`memory_total`

Data type: `Integer`

The total memory in MB to allocate to Oracle.
The default value is: `800`

Default value: `1000`

##### <a name="nationalcharacter_set"></a>`nationalcharacter_set`

Data type: `String[1]`

Use this NLS Character set.
The default value is: `UTF8`

Default value: `'AL16UTF16'`

##### <a name="oracle_base"></a>`oracle_base`

Data type: `String[1]`

A directory to use as Oracle base directory.

Default value: ``undef``

##### <a name="oracle_home"></a>`oracle_home`

Data type: `String[1]`

A directory to be used as Oracle home directory for this software.

Default value: ``undef``

##### <a name="puppet_download_mnt_point"></a>`puppet_download_mnt_point`

Data type: `Optional[String[1]]`

The base path of all remote files for the defined type or class.
The default value is: `puppet:///modules/ora_install`

Default value: ``undef``

##### <a name="recovery_area_destination"></a>`recovery_area_destination`

Data type: `Optional[String[1]]`

Location of the recovary files.

Default value: ``undef``

##### <a name="recovery_diskgroup"></a>`recovery_diskgroup`

Data type: `Optional[String[1]]`

Diskgroup to use for recovery files.

Default value: ``undef``

##### <a name="sample_schema"></a>`sample_schema`

Data type: `Enum['TRUE','FALSE']`

Load the sample schema or not.
**Attention** This is a string and not a boolean value.
The default value is: `TRUE`

Default value: `'TRUE'`

##### <a name="storage_type"></a>`storage_type`

Data type: `Enum['FS','CFS','ASM']`

The storage type to use.
Valid values are:
- `FS`
- `CFS`
- `ASM`
`FS`

Default value: `'FS'`

##### <a name="sys_password"></a>`sys_password`

Data type: `Easy_type::Password`

The password to use for the `SYS` user.

##### <a name="system_password"></a>`system_password`

Data type: `Easy_type::Password`

The password to use for the `SYSTEM` user.

##### <a name="template"></a>`template`

Data type: `Optional[String[1]]`

Use the specified template to create the database.
You can choose between a set of pre-delivered templates, but also specify your own templates.
## Using a pre-delivered template
`ora_install` delivers a few predefined templates.
- dbtemplate_11GR2
- dbtemplate_12.1
- dbtemplate_12.1_asm
Here is an example on how to use this:
```puppet
ora_install::database{ 'testDb_Create':
  ...
  template                  => 'dbtemplate_12.1',
  ...
}
```
## Using your own template
When you specify a template name not pre-delivered by `ora_install`, the defined type will look in the directory specified by `puppet_download_mnt_point` for your own template.
Here is an example:
```puppet
  template                   => 'my_dbtemplate_11gR2_asm',
  puppet_download_mnt_point  => '/vagrant', # 'ora_install' etc
```
The template must be have the following extension dbt.erb like `dbtemplate_12.1.dbt.erb`
- Click here for an [12.1 db instance template example](https://github.com/enterprisemodules/ora_install/blob/master/templates/dbtemplate_12.1.dbt.erb)
- Click here for an [11.2 db asm instance template example](https://github.com/enterprisemodules/ora_install/blob/master/templates/dbtemplate_11gR2_asm.dbt.erb)

Default value: ``undef``

##### <a name="template_type"></a>`template_type`

Data type: `Enum['non-seed','seed']`

The template type `DBCA` uses.
There are two types of templates:
- `non-seed`
- `seed`
The default value is: `non-seed`

Default value: `'non-seed'`

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.
The install class will not create the user for you. You must do that yourself.
The default value is: `oracle`

Default value: `'oracle'`

##### <a name="memory_mgmt_type"></a>`memory_mgmt_type`

Data type: `Enum['AUTO','AUTO_SGA','CUSTOM_SGA']`

The type of memory management to use for the database.
The options are:
- `AUTO`
- `AUTO_SGA`
- `CUSTOM_SGA`
The default is `AUTO_SGA`

Default value: `'AUTO_SGA'`

##### <a name="version"></a>`version`

Data type: `Ora_install::ShortVersion`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: `'12.2'`

### <a name="ora_installdatabase_pluggable"></a>`ora_install::database_pluggable`

ora_install::database_pluggable

Under the hood, this defined type calls the `dbca` utility to create or delete a pluggable database in the specified source database.

Here is an example on how to create pluggable database:

```puppet
ora_install::database_pluggable{'pdb1':
  ensure                   => 'present',
  version                  => '12.1',
  oracle_home_dir          => '/oracle/product/12.1/db',
  user                     => 'oracle',
  group                    => 'dba',
  source_db                => 'orcl',
  pdb_name                 => 'pdb1',
  pdb_admin_username       => 'pdb_adm',
  pdb_admin_password       => 'Welcome01',
  pdb_datafile_destination => "/oracle/oradata/orcl/pdb1",
  create_user_tablespace   => true,
  logoutput                => true,
}
```
Here is an example on how to remove a pluggable database:

```puppet
ora_install::database_pluggable{'pdb1':
  ensure                   => 'absent',
  version                  => '12.1',
  oracle_home_dir          => '/oracle/product/12.1/db',
  user                     => 'oracle',
  group                    => 'dba',
  source_db                => 'orcl',
  pdb_name                 => 'pdb1',
  pdb_datafile_destination => "/oracle/oradata/orcl/pdb1",
  logoutput                => true,
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `ora_install::database_pluggable` defined type:

* [`create_user_tablespace`](#create_user_tablespace)
* [`ensure`](#ensure)
* [`group`](#group)
* [`logoutput`](#logoutput)
* [`oracle_home_dir`](#oracle_home_dir)
* [`pdb_admin_password`](#pdb_admin_password)
* [`pdb_admin_username`](#pdb_admin_username)
* [`pdb_datafile_destination`](#pdb_datafile_destination)
* [`pdb_name`](#pdb_name)
* [`source_db`](#source_db)
* [`user`](#user)
* [`version`](#version)

##### <a name="create_user_tablespace"></a>`create_user_tablespace`

Data type: `Boolean`

Create a user tablespace in the PDB.
The default value is: `false`

Default value: ``true``

##### <a name="ensure"></a>`ensure`

Data type: `Enum[present,absent]`

State to obtain.
The ensure attribute can be one of two values:
- present
- absent
When you specify `present`, Puppet will make sure the resource is available with all specified options and properties.
When the resource is already available(installed), and all attributes are as the are specified, Puppet will do nothing.
When you specify `absent`, Puppet will remove the resource if it is available. If it is not installed, Puppet will do nothing.

Default value: `present`

##### <a name="group"></a>`group`

Data type: `String[1]`

The os group to use for these Oracle puppet definitions.
The default value is: `dba`

Default value: `'dba'`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Boolean,Enum['on_failure']]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup( { name => 'logoutput', default_value => 'on_failure' })`

##### <a name="oracle_home_dir"></a>`oracle_home_dir`

Data type: `Stdlib::Absolutepath`

A directory to be used as Oracle home directory for this software.

Default value: ``undef``

##### <a name="pdb_admin_password"></a>`pdb_admin_password`

Data type: `Easy_type::Password`

Password for the admin user in the PDB.

Default value: ``undef``

##### <a name="pdb_admin_username"></a>`pdb_admin_username`

Data type: `String[1]`

Username for the admin user in the pluggable database.
The default value is: `pdb_adm`

Default value: `'pdb_adm'`

##### <a name="pdb_datafile_destination"></a>`pdb_datafile_destination`

Data type: `String[1]`

The location where the PDB datafiles will be stored.

Default value: ``undef``

##### <a name="pdb_name"></a>`pdb_name`

Data type: `String[1]`

Name of the pluggable database.

Default value: ``undef``

##### <a name="source_db"></a>`source_db`

Data type: `String[1]`

The database name of the container(source) database.

Default value: ``undef``

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.
The install class will not create the user for you. You must do that yourself.
The default value is: `oracle`

Default value: `'oracle'`

##### <a name="version"></a>`version`

Data type: `Enum['12.1','12.2', '18.0', '19.0', '21.0']`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: `'12.1'`

### <a name="ora_installdbactions"></a>`ora_install::dbactions`

ora_install::dbactions

[DEPRECATED]

This is defined type to start or stop a database. Usage of this type is discouraged. Please use [db_control](/docs/ora_install/db_control.html) for this function.

Here is an example on how to use this:
```puppet
ora_install::dbactions{ 'stop testDb':
  db_name     => 'test',
  oracle_home => '/oracle/product/11.2/db',
  user        => 'oracle',
  group       => 'dba',
  action      => 'stop',
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `ora_install::dbactions` defined type:

* [`action`](#action)
* [`db_name`](#db_name)
* [`db_type`](#db_type)
* [`grid_home`](#grid_home)
* [`group`](#group)
* [`oracle_home`](#oracle_home)
* [`user`](#user)

##### <a name="action"></a>`action`

Data type: `Enum['running','start','stop','abort']`

The action you want to take.
Valid values are:
- `start`
- `running`
- `stop`
- `abort`
Default value is: `start`

Default value: `'start'`

##### <a name="db_name"></a>`db_name`

Data type: `String[1]`

The database you want to do the action on.

Default value: `'orcl'`

##### <a name="db_type"></a>`db_type`

Data type: `Enum['database','asm','grid']`

The type of service you want to manage.
Valid values are:
- `database`
- `grid`
- `asm`

Default value: `'database'`

##### <a name="grid_home"></a>`grid_home`

Data type: `Optional[Stdlib::Absolutepath]`

The oracle home directory to use for the GRID software.

Default value: ``undef``

##### <a name="group"></a>`group`

Data type: `String[1]`

The os group to use for these Oracle puppet definitions.
The default value is: `dba`

Default value: `'dba'`

##### <a name="oracle_home"></a>`oracle_home`

Data type: `Stdlib::Absolutepath`

A directory to be used as Oracle home directory for this software.

Default value: ``undef``

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.
The install class will not create the user for you. You must do that yourself.
The default value is: `oracle`

Default value: `'oracle'`

### <a name="ora_installgoldengate"></a>`ora_install::goldengate`

ora_install::goldengate

This module supports the following versions:

- 12.1.2
- 12.2.1
- 18.1.0
- 19.1.0
- 21.3.0

Here is an example on how to use this:

```puppet
ora_install::goldengate{ 'ggate12.1.2':
  version                  => '12.1.2',
  file                     => '121200_fbo_ggs_Linux_x64_shiphome.zip',
  database_type            => 'Oracle',
  database_version         => 'ORA11g',
  database_home            => '/oracle/product/12.1/db',
  oracle_base              => '/oracle',
  goldengate_home          => "/oracle/product/12.1/ggate",
  manager_port             => 16000,
  user                     => 'ggate',
  group                    => 'dba',
  group_install            => 'oinstall',
  download_dir             => '/install',
  puppet_download_mnt_point => puppet://modules/software,
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `ora_install::goldengate` defined type:

* [`database_home`](#database_home)
* [`database_type`](#database_type)
* [`database_version`](#database_version)
* [`download_dir`](#download_dir)
* [`file`](#file)
* [`goldengate_home`](#goldengate_home)
* [`group`](#group)
* [`group_install`](#group_install)
* [`logoutput`](#logoutput)
* [`manager_port`](#manager_port)
* [`oracle_base`](#oracle_base)
* [`puppet_download_mnt_point`](#puppet_download_mnt_point)
* [`temp_dir`](#temp_dir)
* [`umask`](#umask)
* [`user`](#user)
* [`version`](#version)
* [`allow_insecure`](#allow_insecure)
* [`ora_inventory_dir`](#ora_inventory_dir)

##### <a name="database_home"></a>`database_home`

Data type: `Stdlib::Absolutepath`

The home directory of the database.

Default value: ``undef``

##### <a name="database_type"></a>`database_type`

Data type: `Enum['Oracle']`

The type of database.
The default value is: `Oracle`

Default value: `'Oracle'`

##### <a name="database_version"></a>`database_version`

Data type: `Ora_install::DatabaseVersion`

The version of the database.
Valid values are:
- `ORA11g`
- `ORA12c`
- `ORA18c`
- `ORA19c`
Default version is `ORA11g`

Default value: `'ORA11g'`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `'/install'`

##### <a name="file"></a>`file`

Data type: `String[1]`

The file containing the software.

Default value: ``undef``

##### <a name="goldengate_home"></a>`goldengate_home`

Data type: `Stdlib::Absolutepath`

The home to use for the goldengate software.

Default value: ``undef``

##### <a name="group"></a>`group`

Data type: `String[1]`

The os group to use for these Oracle puppet definitions.
The default value is: `dba`

Default value: `'dba'`

##### <a name="group_install"></a>`group_install`

Data type: `String[1]`

The os group to use for installation.
The default value is: `oinstall`

Default value: `'oinstall'`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Boolean,Enum['on_failure']]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup( { name => 'logoutput', default_value => 'on_failure' })`

##### <a name="manager_port"></a>`manager_port`

Data type: `Integer`

The IP port number of the manager.
This is a required value.

Default value: ``undef``

##### <a name="oracle_base"></a>`oracle_base`

Data type: `Stdlib::Absolutepath`

A directory to use as Oracle base directory.

Default value: ``undef``

##### <a name="puppet_download_mnt_point"></a>`puppet_download_mnt_point`

Data type: `Optional[String[1]]`

The base path of all remote files for the defined type or class.
The default value is: `puppet:///modules/ora_install`

Default value: ``undef``

##### <a name="temp_dir"></a>`temp_dir`

Data type: `Stdlib::Absolutepath`

Directory to use for temporary files.

Default value: `'/tmp'`

##### <a name="umask"></a>`umask`

Data type: `String[1]`

The umask to use for commands that run in the context of either the grid user or the oracle user.
The default is `0022`

Default value: `'0022'`

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.
The install class will not create the user for you. You must do that yourself.
The default value is: `oracle`

Default value: `'ggate'`

##### <a name="version"></a>`version`

Data type: `Enum['12.1.2','12.2.1', '12.3.0','18.1.0', '19.1.0', '21.3.0']`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: `'12.3.0'`

##### <a name="allow_insecure"></a>`allow_insecure`

Data type: `Boolean`

When set to `true` Ignore HTTPS certificate errors
(default: false)

Default value: `lookup( { name => 'allow_insecure', default_value => false })`

##### <a name="ora_inventory_dir"></a>`ora_inventory_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The directory that contains the oracle inventory.
The default value is: `/oracle_base/oraInventory`

Default value: ``undef``

### <a name="ora_installinstallasm"></a>`ora_install::installasm`

ora_install::installasm

This defined class supports the following versions of grid:
- 11.2.0.4
- 12.1.0.1
- 12.1.0.2
- 12.2.0.1
- 18.0.0.0
- 19.0.0.0 (and all sub versions)
- 21.0.0.0 (and all sub versions)


Here is an example on how to use this:

```puppet
ora_install::installasm{ 'db_linux-x64':
  version                   => hiera('db_version'),
  file                      => hiera('asm_file'),
  grid_type                 => 'HA_CONFIG',
  grid_base                 => hiera('grid_base_dir'),
  grid_home                 => hiera('grid_home_dir'),
  ora_inventory_dir         => hiera('oraInventory_dir'),
  user_base_dir             => '/home',
  user                      => hiera('grid_os_user'),
  group                     => 'asmdba',
  group_install             => 'oinstall',
  group_oper                => 'asmoper',
  group_asm                 => 'asmadmin',
  sys_asm_password          => 'Welcome01',
  asm_monitor_password      => 'Welcome01',
  asm_diskgroup             => 'DATA',
  disk_discovery_string     => "/nfs_client/asm*",
  disks                     => "/nfs_client/asm_sda_nfs_b1,/nfs_client/asm_sda_nfs_b2",
  # disk_discovery_string   => "ORCL:*",
  # disks                   => "ORCL:DISK1,ORCL:DISK2",
  disk_redundancy           => "EXTERNAL",
  download_dir              => hiera('oracle_download_dir'),
  remote_file               => false,
  puppet_download_mnt_point => hiera('oracle_source'),
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `ora_install::installasm` defined type:

* [`asm_diskgroup`](#asm_diskgroup)
* [`asm_monitor_password`](#asm_monitor_password)
* [`cluster_name`](#cluster_name)
* [`cluster_nodes`](#cluster_nodes)
* [`configure_afd`](#configure_afd)
* [`disk_au_size`](#disk_au_size)
* [`disk_discovery_string`](#disk_discovery_string)
* [`disk_redundancy`](#disk_redundancy)
* [`disks_failgroup_names`](#disks_failgroup_names)
* [`bash_profile`](#bash_profile)
* [`bash_additions`](#bash_additions)
* [`disks`](#disks)
* [`download_dir`](#download_dir)
* [`file`](#file)
* [`gimr_configure`](#gimr_configure)
* [`gimr_dg_ausize`](#gimr_dg_ausize)
* [`gimr_dg_disks`](#gimr_dg_disks)
* [`gimr_dg_disks_failgroup_names`](#gimr_dg_disks_failgroup_names)
* [`gimr_dg_fg_names`](#gimr_dg_fg_names)
* [`gimr_dg_name`](#gimr_dg_name)
* [`gimr_dg_redundancy`](#gimr_dg_redundancy)
* [`grid_base`](#grid_base)
* [`grid_home`](#grid_home)
* [`grid_type`](#grid_type)
* [`group`](#group)
* [`group_asm`](#group_asm)
* [`group_install`](#group_install)
* [`group_oper`](#group_oper)
* [`logoutput`](#logoutput)
* [`network_interface_list`](#network_interface_list)
* [`ora_inventory_dir`](#ora_inventory_dir)
* [`puppet_download_mnt_point`](#puppet_download_mnt_point)
* [`scan_name`](#scan_name)
* [`scan_port`](#scan_port)
* [`stand_alone`](#stand_alone)
* [`storage_option`](#storage_option)
* [`sys_asm_password`](#sys_asm_password)
* [`temp_dir`](#temp_dir)
* [`user`](#user)
* [`umask`](#umask)
* [`user_base_dir`](#user_base_dir)
* [`version`](#version)
* [`zip_extract`](#zip_extract)
* [`install_task`](#install_task)
* [`gimr_dg`](#gimr_dg)
* [`allow_insecure`](#allow_insecure)

##### <a name="asm_diskgroup"></a>`asm_diskgroup`

Data type: `String[1]`

The name of the ASM diskgroup to use.
`DATA`

Default value: `'DATA'`

##### <a name="asm_monitor_password"></a>`asm_monitor_password`

Data type: `Easy_type::Password`

The password for the ASMSNMP user for monitoring in EM.

##### <a name="cluster_name"></a>`cluster_name`

Data type: `Optional[String[1]]`

The name of the cluster.

Default value: ``undef``

##### <a name="cluster_nodes"></a>`cluster_nodes`

Data type: `Optional[String[1]]`

The names of the nodes in the RAC cluster.
Valid values are:
- `node1:node1-vip,node2:node2-vip`                     (version >= 11 <= 12.1)
- `node1:node1-vip:HUB,node2:node2-vip:LEAF`            (version >= 12.1 Flex Cluster)
- `node1,node2`                                         (version = 12.2 Application Cluster)
- `node1:node1-vip:HUB:site1,node2:node2-vip:HUB:site2` (version = 12.2 Extended Cluster)

Default value: ``undef``

##### <a name="configure_afd"></a>`configure_afd`

Data type: `Boolean`

Specify whether or not to configure ASM Filter Driver instead of ASMLib.
The default value is: `false`

Default value: ``false``

##### <a name="disk_au_size"></a>`disk_au_size`

Data type: `Enum['1','2','4','8','16','32','64']`

The disk_au size to use for the ASM disks.
**Attention** this is a String value not an Integer.
The default value is: `1`

Default value: `'1'`

##### <a name="disk_discovery_string"></a>`disk_discovery_string`

Data type: `Optional[String[1]]`

The search string to use for discovering disks for ASM.

Default value: ``undef``

##### <a name="disk_redundancy"></a>`disk_redundancy`

Data type: `Enum['NORMAL','HIGH','EXTERNAL']`

The type of redundancy to use.
Valid values are:
- `NORMAL`
- `HIGH`
- `EXTERNAL`
The default value is: `NORMAL`

Default value: `'NORMAL'`

##### <a name="disks_failgroup_names"></a>`disks_failgroup_names`

Data type: `Optional[String[1]]`

A comma seperated list of device and failure group name.
Valid values are:
- `/dev/sdb,CRSFG1,/dev/sdc,CRSFG2,/dev/sdd,CRSFG3`                                 (NORMAL redundancy)
- `/dev/sdb,,/dev/sdc,,/dev/sdd,,/dev/sde,`                                         (EXTERNAL redundancy)
- `/dev/sdb,CRSFG1,/dev/sdc,CRSFG2,/dev/sdd,CRSFG3,/dev/sde,CRSFG4,/dev/sdf,CRSFG5` (HIGH redundancy)

Default value: ``undef``

##### <a name="bash_profile"></a>`bash_profile`

Data type: `Boolean`

Create a bash profile for the specified user or not.
Valid values are `true` and `false`.
When you specify a `true` for the parameter, Puppet will create a standard bash profile for the specified user. The bash profile will be placed in a directory named `user_base_dir/user`.
```puppet
ora_install::client { 'Oracle client':
  ...
  bash_profile  => true,
  user          => 'oracle',
  user_base_dir => '/home',
  ...
}
```
This snippet will create a bash profile called `/home/oracle/.bash_profile`.

Default value: ``true``

##### <a name="bash_additions"></a>`bash_additions`

Data type: `String`

The text to add at the end of the bash_profile.
This parameter will only be used when you have specified `true` for the parameter `bash_profile`
The default value is an empty string.

Default value: `''`

##### <a name="disks"></a>`disks`

Data type: `Optional[String[1]]`

List of disks to create a ASM DiskGroup.

Default value: ``undef``

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `'/install'`

##### <a name="file"></a>`file`

Data type: `String[1]`

The source file to use.

Default value: ``undef``

##### <a name="gimr_configure"></a>`gimr_configure`

Data type: `Boolean`

Specify whether or not to configure GIMR database (MGMTDB), 19c and higher only.
The default value is: `false`

Default value: ``false``

##### <a name="gimr_dg_ausize"></a>`gimr_dg_ausize`

Data type: `Enum['1','2','4','8','16','32','64']`

The disk_au size to use for the for the GIMR database (MGMTDB) diskgroup.
**Attention** this is a String value not an Integer.
The default value is: `1`

Default value: `'1'`

##### <a name="gimr_dg_disks"></a>`gimr_dg_disks`

Data type: `Optional[String[1]]`

List of disks to create the GIMR database (MGMTDB).

Default value: ``undef``

##### <a name="gimr_dg_disks_failgroup_names"></a>`gimr_dg_disks_failgroup_names`

Data type: `Optional[String[1]]`

A comma seperated list of device and failure group name for the GIMR database (MGMTDB).
Valid values are:
- `/dev/sdb,GIMRFG1,/dev/sdc,GIMRFG2,/dev/sdd,GIMRFG3`                                   (NORMAL redundancy)
- `/dev/sdb,,/dev/sdc,,/dev/sdd,,/dev/sde,`                                              (EXTERNAL redundancy)
- `/dev/sdb,GIMRFG1,/dev/sdc,GIMRFG2,/dev/sdd,GIMRFG3,/dev/sde,GIMRFG4,/dev/sdf,GIMRFG5` (HIGH redundancy)

Default value: ``undef``

##### <a name="gimr_dg_fg_names"></a>`gimr_dg_fg_names`

Data type: `Optional[String[1]]`

Failure Groups for the GIMR storage data ASM disk group.

Default value: ``undef``

##### <a name="gimr_dg_name"></a>`gimr_dg_name`

Data type: `Optional[String[1]]`

Specify the name of the diskgroup for the GIMR database (MGMTDB), 12.
2 and up only.

Default value: ``undef``

##### <a name="gimr_dg_redundancy"></a>`gimr_dg_redundancy`

Data type: `Optional[Enum['NORMAL','HIGH','EXTERNAL']]`

The type of redundancy to use for the GIMR database (MGMTDB) diskgroup.
Valid values are:
- `NORMAL`
- `HIGH`
- `EXTERNAL`

Default value: ``undef``

##### <a name="grid_base"></a>`grid_base`

Data type: `Stdlib::Absolutepath`

The directory to use as grid base.

Default value: ``undef``

##### <a name="grid_home"></a>`grid_home`

Data type: `Stdlib::Absolutepath`

The directory to use as grid home.

Default value: ``undef``

##### <a name="grid_type"></a>`grid_type`

Data type: `Enum['CRS_CONFIG','HA_CONFIG','UPGRADE','CRS_SWONLY','HA_SWONLY']`

The type of grid.
Valid values are:
- `HA_CONFIG`
- `CRS_CONFIG`
- `HA_SWONLY`   (versions > 11)
- `UPGRADE`
- `CRS_SWONLY`
The default value is: `HA_CONFIG`

Default value: `'HA_CONFIG'`

##### <a name="group"></a>`group`

Data type: `String[1]`

The os group to use for these Oracle puppet definitions.
The default value is: `dba`

Default value: `'asmdba'`

##### <a name="group_asm"></a>`group_asm`

Data type: `String[1]`

The OS group to use.
The default value is: `asmdba`

Default value: `'asmadmin'`

##### <a name="group_install"></a>`group_install`

Data type: `String[1]`

The os group to use for installation.
The default value is: `oinstall`

Default value: `'oinstall'`

##### <a name="group_oper"></a>`group_oper`

Data type: `String[1]`

The OS group to allow ASM oper operations.
The default value is: `asmoper`

Default value: `'asmoper'`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Boolean,Enum['on_failure']]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup( { name => 'logoutput', default_value => 'on_failure' })`

##### <a name="network_interface_list"></a>`network_interface_list`

Data type: `Optional[String[1]]`

The list of interfaces to use for RAC.
The value should be a comma separated strings where each string is as shown below
```
InterfaceName:SubnetAddress:InterfaceType
```
where InterfaceType can be either "1", "2", or "3" (1 indicates public, 2 indicates private, and 3 indicates the interface is not used)
An example on how to use this:
```puppet
installasm{'asm12':
  ...
  network_interface_list => 'eth0:140.87.24.0:1,eth1:10.2.1.0:2,eth2:140.87.52.0:3'
  ...
}
```

Default value: ``undef``

##### <a name="ora_inventory_dir"></a>`ora_inventory_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The directory that contains the oracle inventory.
The default value is: `/oracle_base/oraInventory`

Default value: ``undef``

##### <a name="puppet_download_mnt_point"></a>`puppet_download_mnt_point`

Data type: `Optional[String[1]]`

The base path of all remote files for the defined type or class.
The default value is: `puppet:///modules/ora_install`

Default value: ``undef``

##### <a name="scan_name"></a>`scan_name`

Data type: `Optional[String[1]]`

The name to use for the SCAN service.

Default value: ``undef``

##### <a name="scan_port"></a>`scan_port`

Data type: `Optional[Integer]`

The IP portnumber to use for the SCAN service.

Default value: ``undef``

##### <a name="stand_alone"></a>`stand_alone`

Data type: `Boolean`

Configuring Grid Infrastructure for a Stand-Alone Server.
The default value is: `true`

Default value: ``true``

##### <a name="storage_option"></a>`storage_option`

Data type: `Optional[Enum['FLEX_ASM_STORAGE','CLIENT_ASM_STORAGE','LOCAL_ASM_STORAGE','FILE_SYSTEM_STORAGE','ASM_STORAGE']]`

The type of storage to use.
Valid values are:
- `ASM_STORAGE`          (versions = 11)
- `FILE_SYSTEM_STORAGE`  (versions <= 12.1)
- `LOCAL_ASM_STORAGE`    (versions >= 12.1)
- `CLIENT_ASM_STORAGE`   (versions >= 12.2)
- `FLEX_ASM_STORAGE`     (versions >= 12.1)

Default value: ``undef``

##### <a name="sys_asm_password"></a>`sys_asm_password`

Data type: `Easy_type::Password`

The password to use for the SYSASM user.

##### <a name="temp_dir"></a>`temp_dir`

Data type: `Stdlib::Absolutepath`

Directory to use for temporary files.

Default value: `'/tmp'`

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.
The install class will not create the user for you. You must do that yourself.
The default value is: `oracle`

Default value: `'grid'`

##### <a name="umask"></a>`umask`

Data type: `String[1]`

The umask to use for commands that run in the context of either the grid user or the oracle user.
The default is `0022`

Default value: `'0022'`

##### <a name="user_base_dir"></a>`user_base_dir`

Data type: `Stdlib::Absolutepath`

The directory to use as base directory for the users.

Default value: `'/home'`

##### <a name="version"></a>`version`

Data type: `Ora_install::Version`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: ``undef``

##### <a name="zip_extract"></a>`zip_extract`

Data type: `Boolean`

The specified source file is a zip file that needs te be extracted.
When you specify a value of false, the source attribute must contain a reference to a directory instead of a zip file.
The default value is: `true`

Default value: ``true``

##### <a name="install_task"></a>`install_task`

Data type: `Enum['ALL','EXTRACT','SETUP']`

Kind of install task you want the class to do.

Default value: `'ALL'`

##### <a name="gimr_dg"></a>`gimr_dg`

Data type: `Boolean`

Specify whether or not to configure a seperate diskgroup for the GIMR database (MGMTDB), 12.
2 and up only.
The default value is: `false`

Default value: ``false``

##### <a name="allow_insecure"></a>`allow_insecure`

Data type: `Boolean`

When set to `true` Ignore HTTPS certificate errors
(default: false)

Default value: `lookup( { name => 'allow_insecure', default_value => false })`

### <a name="ora_installinstalldb"></a>`ora_install::installdb`

ora_install::installdb

This defined type supports the following versions of Oracle:

- 11.2.0.1
- 11.2.0.3
- 11.2.0.4
- 12.1.0.1
- 12.1.0.2
- 12.2.0.1
- 18.0.0.0
- 19.0.0.0 ( and all subversions)
- 21.0.0.0 ( and all subversions)

## Example

Here is an example on how you can use this class to install an Oracle database
on your system.

```puppet
ora_install::installdb{ '12.1.0.2_Linux-x86-64':
  version                   => '12.1.0.2',
  file                      => 'V46095-01',
  database_type             => 'SE',
  oracle_base               => '/oracle',
  oracle_home               => '/oracle/product/12.1/db',
  bash_profile              => true,
  user                      => 'oracle',
  group                     => 'dba',
  group_install             => 'oinstall',
  group_oper                => 'oper',
  download_dir              => '/data/install',
  zip_extract               => true,
  puppet_download_mnt_point => $puppet_download_mnt_point,
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `ora_install::installdb` defined type:

* [`database_type`](#database_type)
* [`download_dir`](#download_dir)
* [`bash_profile`](#bash_profile)
* [`bash_additions`](#bash_additions)
* [`cleanup_install_files`](#cleanup_install_files)
* [`cluster_nodes`](#cluster_nodes)
* [`ee_optional_components`](#ee_optional_components)
* [`ee_options_selection`](#ee_options_selection)
* [`file`](#file)
* [`group`](#group)
* [`group_install`](#group_install)
* [`group_oper`](#group_oper)
* [`is_rack_one_install`](#is_rack_one_install)
* [`ora_inventory_dir`](#ora_inventory_dir)
* [`oracle_base`](#oracle_base)
* [`oracle_home`](#oracle_home)
* [`puppet_download_mnt_point`](#puppet_download_mnt_point)
* [`temp_dir`](#temp_dir)
* [`bypass_tmp_noexec`](#bypass_tmp_noexec)
* [`user`](#user)
* [`umask`](#umask)
* [`user_base_dir`](#user_base_dir)
* [`version`](#version)
* [`zip_extract`](#zip_extract)
* [`user_password`](#user_password)
* [`logoutput`](#logoutput)
* [`allow_insecure`](#allow_insecure)

##### <a name="database_type"></a>`database_type`

Data type: `Enum['SE2', 'SE', 'EE', 'SEONE']`

Selects the type of database you want to install.
At this point in time the following database types are supported and allowed:
- `EE`     : Enterprise Edition   (all versions)
- `SE`     : Standard Edition     (versions <= 12.1.0.1)
- `SEONE`  : Standard Edition One (versions <= 12.1.0.1)
- `SE2`    : Standard Edition Two (versions >= 12.1.0.2)
The default value is: `SE2`

Default value: `'SE2'`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `'/install'`

##### <a name="bash_profile"></a>`bash_profile`

Data type: `Boolean`

Create a bash profile for the specified user or not.
Valid values are `true` and `false`.
When you specify a `true` for the parameter, Puppet will create a standard bash profile for the specified user. The bash profile will be placed in a directory named `user_base_dir/user`.
```puppet
ora_install::client { 'Oracle client':
  ...
  bash_profile  => true,
  user          => 'oracle',
  user_base_dir => '/home',
  ...
}
```
This snippet will create a bash profile called `/home/oracle/.bash_profile`.

Default value: ``true``

##### <a name="bash_additions"></a>`bash_additions`

Data type: `String`

The text to add at the end of the bash_profile.
This parameter will only be used when you have specified `true` for the parameter `bash_profile`
The default value is an empty string.

Default value: `''`

##### <a name="cleanup_install_files"></a>`cleanup_install_files`

Data type: `Boolean`

Cleanup extracted files after use.
This is a boolean value. When you set this value to `true`. The installer class will
remove all extracted zip files after it has done its work.
The default value is: `true`
Here is an example:
```puppet
ora_install::....{...
  ...
  cleanup_install_files => false,  # Keep all unzipped files
  ...
}
```

Default value: ``true``

##### <a name="cluster_nodes"></a>`cluster_nodes`

Data type: `Optional[String[1]]`

A comma seperated list of the nodes running in the RAC cluster.
Example: `node1,node2`

Default value: ``undef``

##### <a name="ee_optional_components"></a>`ee_optional_components`

Data type: `Optional[String[1]]`

This variable is used to enable or disable custom install.
When its is set to  true, the attribute `ee_options_selection` is used. When this value is false, the attribute `ee_options_selection` is ignored.

Default value: ``undef``

##### <a name="ee_options_selection"></a>`ee_options_selection`

Data type: `Boolean`

List of Enterprise Edition Options you would like to install.
Check the oracle documentation what values are valid.

Default value: ``false``

##### <a name="file"></a>`file`

Data type: `String[1]`

The source file to use.

Default value: ``undef``

##### <a name="group"></a>`group`

Data type: `String[1]`

The os group to use for these Oracle puppet definitions.
The default value is: `dba`

Default value: `'dba'`

##### <a name="group_install"></a>`group_install`

Data type: `String[1]`

The os group to use for installation.
The default value is: `oinstall`

Default value: `'oinstall'`

##### <a name="group_oper"></a>`group_oper`

Data type: `String[1]`

The OS group to allow operator rights.
The default value is: `oper`

Default value: `'oper'`

##### <a name="is_rack_one_install"></a>`is_rack_one_install`

Data type: `Boolean`

This variable is used to enable or disable RAC One Node install.
- true  : Value of RAC One Node service name is used.
- false : Value of RAC One Node service name is not used.
The default value is: `false`

Default value: ``false``

##### <a name="ora_inventory_dir"></a>`ora_inventory_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The directory that contains the oracle inventory.
The default value is: `/oracle_base/oraInventory`

Default value: ``undef``

##### <a name="oracle_base"></a>`oracle_base`

Data type: `Stdlib::Absolutepath`

A directory to use as Oracle base directory.

Default value: ``undef``

##### <a name="oracle_home"></a>`oracle_home`

Data type: `Stdlib::Absolutepath`

A directory to be used as Oracle home directory for this software.

Default value: ``undef``

##### <a name="puppet_download_mnt_point"></a>`puppet_download_mnt_point`

Data type: `Optional[String[1]]`

The base path of all remote files for the defined type or class.
The default value is: `puppet:///modules/ora_install`

Default value: ``undef``

##### <a name="temp_dir"></a>`temp_dir`

Data type: `Stdlib::Absolutepath`

Directory to use for temporary files.

Default value: `'/tmp'`

##### <a name="bypass_tmp_noexec"></a>`bypass_tmp_noexec`

Data type: `Boolean`

This variable is used to enable or disable bypassing noexec mount option on $temp_dir.
- true  : The $temp_dir filesystem will be remounted with exec option for the duration
          of the database software installation, provided $temp_dir is a filesystem.
- false : The $temp_dir filesystem will be left alone.
The default value is: `true`

Default value: ``true``

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.
The install class will not create the user for you. You must do that yourself.
The default value is: `oracle`

Default value: `'oracle'`

##### <a name="umask"></a>`umask`

Data type: `String[1]`

The umask to use for commands that run in the context of either the grid user or the oracle user.
The default is `0022`

Default value: `'0022'`

##### <a name="user_base_dir"></a>`user_base_dir`

Data type: `Stdlib::Absolutepath`

The directory to use as base directory for the users.

Default value: `'/home'`

##### <a name="version"></a>`version`

Data type: `Ora_install::Version`

Specifies the version of the component you want to manage or install.
At this point in type we support the installation of:
- `11.2.0.1`
- `11.2.0.3`
- `11.2.0.4`
- `12.1.0.1`
- `12.1.0.2`
- `12.2.0.1`
- `18.0.0.0`
- `19.0.0.0` (and all subversions)
- `21.0.0.0` (and all subversions)
Here is an example on how to specify the version:
```puppet
ora_install::....{...
  ...
  version => '12.1.0.2',
  ...
}
```

Default value: ``undef``

##### <a name="zip_extract"></a>`zip_extract`

Data type: `Boolean`

The specified source file is a zip file that needs te be extracted.
When you specify a value of false, the source attribute must contain a reference to a directory instead of a zip file.
The default value is: `true`

Default value: ``true``

##### <a name="user_password"></a>`user_password`

Data type: `Optional[String[1]]`

The password for the Oracle user on Windows.
This parameter is only used on windows systems

Default value: ``undef``

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Boolean, Enum['on_failure']]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup( { name => 'logoutput', default_value => 'on_failure' })`

##### <a name="allow_insecure"></a>`allow_insecure`

Data type: `Boolean`

When set to `true` Ignore HTTPS certificate errors
(default: false)

Default value: `lookup( { name => 'allow_insecure', default_value => false })`

### <a name="ora_installinstallem"></a>`ora_install::installem`

ora_install::installem

Here is an example on how to use this:

```puppet
ora_install::installem{ 'em13200':
  version                     => '13.2.0.0',
  file                        => 'em13200p1_linux64',
  oracle_base_dir             => '/u01/app/oracle',
  oracle_home_dir             => '/u01/app/oracle/product/13.2.0.0/em_home1',
  agent_base_dir              => '/u01/app/oracle/agent',
  software_library_dir        => '/u01/app/oracle/swlib',
  weblogic_user               => 'weblogic',
  weblogic_password           => 'Welcome01',
  database_hostname           => 'em1320.example.com',
  database_listener_port      => 1521,
  database_service_sid_name   => 'EM122.domain.local',
  database_sys_password       => 'Welcome01',
  sysman_password             => 'Welcome01',
  agent_registration_password => 'Welcome01',
  deployment_size             => 'SMALL',
  user                        => 'oracle',
  group                       => 'oinstall',
  download_dir                => '/install',
  zip_extract                 => true,
  puppet_download_mnt_point   => 'puppet:///modules/software',
  logoutput                   => true,
}

```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `ora_install::installem` defined type:

* [`admin_server_https_port`](#admin_server_https_port)
* [`agent_base_dir`](#agent_base_dir)
* [`agent_port`](#agent_port)
* [`agent_registration_password`](#agent_registration_password)
* [`bi_publisher_http_port`](#bi_publisher_http_port)
* [`bi_publisher_https_port`](#bi_publisher_https_port)
* [`database_hostname`](#database_hostname)
* [`database_listener_port`](#database_listener_port)
* [`database_service_sid_name`](#database_service_sid_name)
* [`database_sys_password`](#database_sys_password)
* [`deployment_size`](#deployment_size)
* [`download_dir`](#download_dir)
* [`em_central_console_http_port`](#em_central_console_http_port)
* [`em_central_console_https_port`](#em_central_console_https_port)
* [`em_upload_http_port`](#em_upload_http_port)
* [`em_upload_https_port`](#em_upload_https_port)
* [`file`](#file)
* [`group`](#group)
* [`logoutput`](#logoutput)
* [`managed_server_http_port`](#managed_server_http_port)
* [`managed_server_https_port`](#managed_server_https_port)
* [`nodemanager_https_port`](#nodemanager_https_port)
* [`ora_inventory_dir`](#ora_inventory_dir)
* [`oracle_base_dir`](#oracle_base_dir)
* [`oracle_home_dir`](#oracle_home_dir)
* [`puppet_download_mnt_point`](#puppet_download_mnt_point)
* [`software_library_dir`](#software_library_dir)
* [`swonly`](#swonly)
* [`sysman_password`](#sysman_password)
* [`temp_dir`](#temp_dir)
* [`user`](#user)
* [`version`](#version)
* [`weblogic_password`](#weblogic_password)
* [`weblogic_user`](#weblogic_user)
* [`zip_extract`](#zip_extract)
* [`allow_insecure`](#allow_insecure)
* [`tablespace_location`](#tablespace_location)

##### <a name="admin_server_https_port"></a>`admin_server_https_port`

Data type: `Integer`

The https IP port from the WLS Admin server.
The default value is: `7101`

Default value: `7101`

##### <a name="agent_base_dir"></a>`agent_base_dir`

Data type: `Stdlib::Absolutepath`

The directory to use as base for the agent software.

Default value: ``undef``

##### <a name="agent_port"></a>`agent_port`

Data type: `Integer`

The IP port to use to for the agent.
The default value is: `3872`

Default value: `3872`

##### <a name="agent_registration_password"></a>`agent_registration_password`

Data type: `Easy_type::Password`

The password to use to register the agent.

##### <a name="bi_publisher_http_port"></a>`bi_publisher_http_port`

Data type: `Integer`

The http port to use for the BI Publisher.
The default value is: `9701`

Default value: `9701`

##### <a name="bi_publisher_https_port"></a>`bi_publisher_https_port`

Data type: `Integer`

The https port to use for the BI Publisher.
The default value is: `9801`

Default value: `9801`

##### <a name="database_hostname"></a>`database_hostname`

Data type: `String[1]`

The DNS name of the database host.

Default value: ``undef``

##### <a name="database_listener_port"></a>`database_listener_port`

Data type: `Integer`

The IP port for the database listener.
The default value is: `1521`

Default value: `1521`

##### <a name="database_service_sid_name"></a>`database_service_sid_name`

Data type: `String[1]`

The database service SID name for the database.

Default value: ``undef``

##### <a name="database_sys_password"></a>`database_sys_password`

Data type: `Easy_type::Password`

The password of the SYS user of the database.

##### <a name="deployment_size"></a>`deployment_size`

Data type: `Enum['SMALL','MEDIUM','LARGE']`

The size of the deployment.
Valid values are:
- `SMALL`
- `MEDIUM`
- `LARGE`
The default value is: `SMALL`

Default value: `'SMALL'`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `'/install'`

##### <a name="em_central_console_http_port"></a>`em_central_console_http_port`

Data type: `Integer`

The port number of the HTTP port for the central console.
The default value is: `7788`

Default value: `7788`

##### <a name="em_central_console_https_port"></a>`em_central_console_https_port`

Data type: `Integer`

The port number of the HTTPS port for the central console.
The default value is: `7799`

Default value: `7799`

##### <a name="em_upload_http_port"></a>`em_upload_http_port`

Data type: `Integer`

The port number of the HTTP port for the upload service.
The default value is: `1159`

Default value: `4889`

##### <a name="em_upload_https_port"></a>`em_upload_https_port`

Data type: `Integer`

The port number of the HTTPS port for the upload service.
The default value is: `4889`

Default value: `1159`

##### <a name="file"></a>`file`

Data type: `String[1]`

The source file to use.

Default value: ``undef``

##### <a name="group"></a>`group`

Data type: `String[1]`

The os group to use for these Oracle puppet definitions.
The default value is: `dba`

Default value: `'oinstall'`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Boolean,Enum['on_failure']]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup( { name => 'logoutput', default_value => 'on_failure' })`

##### <a name="managed_server_http_port"></a>`managed_server_http_port`

Data type: `Integer`

The port number of the HTTP port for the Managed server.
The default value is: `7201`

Default value: `7201`

##### <a name="managed_server_https_port"></a>`managed_server_https_port`

Data type: `Integer`

The port number of the HTTPS port for the Managed server.
The default value is: `7301`

Default value: `7301`

##### <a name="nodemanager_https_port"></a>`nodemanager_https_port`

Data type: `Integer`

The port number of the HTTPS port for the Node manager.
The default value is: `7401`

Default value: `7401`

##### <a name="ora_inventory_dir"></a>`ora_inventory_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The directory that contains the oracle inventory.
The default value is: `/oracle_base/oraInventory`

Default value: ``undef``

##### <a name="oracle_base_dir"></a>`oracle_base_dir`

Data type: `Stdlib::Absolutepath`

A directory to use as Oracle base directory.

Default value: ``undef``

##### <a name="oracle_home_dir"></a>`oracle_home_dir`

Data type: `Stdlib::Absolutepath`

A directory to be used as Oracle home directory for this software.

Default value: ``undef``

##### <a name="puppet_download_mnt_point"></a>`puppet_download_mnt_point`

Data type: `String[1]`

The base path of all remote files for the defined type or class.
The default value is: `puppet:///modules/ora_install`

Default value: ``undef``

##### <a name="software_library_dir"></a>`software_library_dir`

Data type: `Stdlib::Absolutepath`

The directory to use for the software library.

Default value: ``undef``

##### <a name="swonly"></a>`swonly`

Data type: `Boolean`

Only install the software without configuration (true) or not (false).
The default value is: `false`

Default value: ``false``

##### <a name="sysman_password"></a>`sysman_password`

Data type: `Easy_type::Password`

The password to use for sysman.

##### <a name="temp_dir"></a>`temp_dir`

Data type: `Stdlib::Absolutepath`

Directory to use for temporary files.

Default value: `'/tmp'`

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.
The install class will not create the user for you. You must do that yourself.
The default value is: `oracle`

Default value: `'oracle'`

##### <a name="version"></a>`version`

Data type: `Enum[
    '12.1.0.4',
    '12.1.0.5',
    '13.1.0.0',
    '13.2.0.0',
    '13.3.0.0',
    '13.4.0.0',
    '13.5.0.0']`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: `'12.1.0.5'`

##### <a name="weblogic_password"></a>`weblogic_password`

Data type: `Easy_type::Password`

The password to use for WebLogic.

##### <a name="weblogic_user"></a>`weblogic_user`

Data type: `String[1]`

The username to use for WebLogic.
The default value is: `weblogic`

Default value: `'weblogic'`

##### <a name="zip_extract"></a>`zip_extract`

Data type: `Boolean`

The specified source file is a zip file that needs te be extracted.
When you specify a value of false, the source attribute must contain a reference to a directory instead of a zip file.
The default value is: `true`

Default value: ``true``

##### <a name="allow_insecure"></a>`allow_insecure`

Data type: `Boolean`

When set to `true` Ignore HTTPS certificate errors
(default: false)

Default value: `lookup( { name => 'allow_insecure', default_value => false })`

##### <a name="tablespace_location"></a>`tablespace_location`

Data type: `Optional[String[1]]`

The location where the tablespace datafiles should be located.
Only needed to specify when using ASM as underlying storage.

Default value: ``undef``

### <a name="ora_installinstallem_agent"></a>`ora_install::installem_agent`

ora_install::installem_agent

This defined type supports the following versions of Enterprise Manager:
- 12.1.0.4
- 12.1.0.5
- 13.1.0.0
- 13.2.0.0
- 13.3.0.0
- 13.3.0.0
- 13.4.0.0
- 13.5.0.0

Here is an example:

```puppet
ora_install::installem_agent{ 'Install em agent':
  version                     => '13.2.0.0',
  install_type                => 'agentPull',
  install_version             => '13.2.0.0.0',
  oracle_base_dir             => '/u01/app',
  agent_base_dir              => '/u01/app/agent/product',
  agent_instance_home_dir     => '/u01/app/agent/product/agent_inst',
  agent_registration_password => 'regme',
  agent_port                  => 3872,
  sysman_password             => 'Welkom01',
  oms_host                    => 'em1320.example.com',
  oms_port                    => 7799,
  em_upload_port              => 1159,
  logoutput                   => true,
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `ora_install::installem_agent` defined type:

* [`agent_base_dir`](#agent_base_dir)
* [`agent_instance_home_dir`](#agent_instance_home_dir)
* [`agent_port`](#agent_port)
* [`agent_registration_password`](#agent_registration_password)
* [`download_dir`](#download_dir)
* [`em_upload_port`](#em_upload_port)
* [`group`](#group)
* [`install_platform`](#install_platform)
* [`install_type`](#install_type)
* [`install_version`](#install_version)
* [`logoutput`](#logoutput)
* [`oms_host`](#oms_host)
* [`oms_port`](#oms_port)
* [`ora_inventory_dir`](#ora_inventory_dir)
* [`oracle_base_dir`](#oracle_base_dir)
* [`source`](#source)
* [`sysman_password`](#sysman_password)
* [`sysman_user`](#sysman_user)
* [`user`](#user)
* [`version`](#version)
* [`temp_dir`](#temp_dir)
* [`allow_insecure`](#allow_insecure)

##### <a name="agent_base_dir"></a>`agent_base_dir`

Data type: `Stdlib::Absolutepath`

The directory to use as base for the agent software.

Default value: ``undef``

##### <a name="agent_instance_home_dir"></a>`agent_instance_home_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The directory to use as instance home.

Default value: ``undef``

##### <a name="agent_port"></a>`agent_port`

Data type: `Integer`

The IP port to use to for the agent.
The default value is: `3872`

Default value: `1830`

##### <a name="agent_registration_password"></a>`agent_registration_password`

Data type: `Optional[Easy_type::Password]`

The password to use to register the agent.

Default value: ``undef``

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `'/install'`

##### <a name="em_upload_port"></a>`em_upload_port`

Data type: `Integer`

The port number of the HTTP port for the upload service.
The default value is: `1159`

Default value: ``undef``

##### <a name="group"></a>`group`

Data type: `String[1]`

The os group to use for these Oracle puppet definitions.
The default value is: `dba`

Default value: `'oinstall'`

##### <a name="install_platform"></a>`install_platform`

Data type: `String[1]`

The type of platform you want to install.
The default value is: `Linux x86-64`

Default value: `'Linux x86-64'`

##### <a name="install_type"></a>`install_type`

Data type: `Enum['agentPull','agentDeploy']`

The type of install.
valid values are:
- `undefined`
- `agentPull`
- `agentDeploy`
The default value is: `undefined`

Default value: ``undef``

##### <a name="install_version"></a>`install_version`

Data type: `Enum[
    '12.1.0.4.0',
    '12.1.0.5.0',
    '13.1.0.0.0',
    '13.2.0.0.0',
    '13.3.0.0.0',
    '13.4.0.0.0',
    '13.5.0.0.0']`

The version you want to install.
The default value is: `12.1.0.5.0`

Default value: `'12.1.0.5.0'`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Boolean, Enum['on_failure']]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup( { name => 'logoutput', default_value => 'on_failure' })`

##### <a name="oms_host"></a>`oms_host`

Data type: `String[1]`

The OMS host to use.

Default value: ``undef``

##### <a name="oms_port"></a>`oms_port`

Data type: `Integer`

The IP port to use for connecting to the OMS host.

Default value: ``undef``

##### <a name="ora_inventory_dir"></a>`ora_inventory_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The directory that contains the oracle inventory.
The default value is: `/oracle_base/oraInventory`

Default value: ``undef``

##### <a name="oracle_base_dir"></a>`oracle_base_dir`

Data type: `Stdlib::Absolutepath`

A directory to use as Oracle base directory.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String[1]]`

The source to use for the installation of the EM agent.
Valid values are:
- an URL like: `https://<OMS_HOST>:<OMS_PORT>/em/install/getAgentImage`
- a local file like: `/tmp/12.1.0.4.0_AgentCore_226_Linux_x64.zip`

Default value: ``undef``

##### <a name="sysman_password"></a>`sysman_password`

Data type: `Optional[Easy_type::Password]`

The password to use for sysman.

Default value: ``undef``

##### <a name="sysman_user"></a>`sysman_user`

Data type: `String[1]`

The sysman user.
The default value is: `sysman`

Default value: `'sysman'`

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.
The install class will not create the user for you. You must do that yourself.
The default value is: `oracle`

Default value: `'oracle'`

##### <a name="version"></a>`version`

Data type: `Enum[
    '12.1.0.4',
    '12.1.0.5',
    '13.1.0.0',
    '13.2.0.0',
    '13.3.0.0',
    '13.4.0.0',
    '13.5.0.0']`

The agent version to be installed
- `12.1.0.4`
- `12.1.0.5`
- `13.1.0.0`
- `13.2.0.0`

Default value: `'12.1.0.5'`

##### <a name="temp_dir"></a>`temp_dir`

Data type: `Stdlib::Absolutepath`

Directory to use for temporary files.

Default value: `'/tmp'`

##### <a name="allow_insecure"></a>`allow_insecure`

Data type: `Boolean`

When set to `true` Ignore HTTPS certificate errors
(default: false)

Default value: `lookup( { name => 'allow_insecure', default_value => false })`

### <a name="ora_installnet"></a>`ora_install::net`

ora_install::net

This defined type allows you to install and configure Oracle SQL*net.

```puppet
ora_install::net{ 'config net8':
  oracle_home   => '/oracle/product/11.2/db',
  version       => '11.2',
  user          => 'oracle',
  group         => 'dba',
  download_dir  => '/install',
  db_port       => 1521,
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `ora_install::net` defined type:

* [`db_port`](#db_port)
* [`download_dir`](#download_dir)
* [`group`](#group)
* [`logoutput`](#logoutput)
* [`oracle_home`](#oracle_home)
* [`temp_dir`](#temp_dir)
* [`user`](#user)
* [`version`](#version)
* [`listener_name`](#listener_name)

##### <a name="db_port"></a>`db_port`

Data type: `Integer`

The IP port number to use for connecting to the database.
The default value is: `1521`

Default value: `1521`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `'/install'`

##### <a name="group"></a>`group`

Data type: `String[1]`

The os group to use for these Oracle puppet definitions.
The default value is: `dba`

Default value: `'dba'`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Boolean,Enum['on_failure']]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup( { name => 'logoutput', default_value => 'on_failure' })`

##### <a name="oracle_home"></a>`oracle_home`

Data type: `Stdlib::Absolutepath`

A directory to be used as Oracle home directory for this software.

Default value: ``undef``

##### <a name="temp_dir"></a>`temp_dir`

Data type: `Stdlib::Absolutepath`

Directory to use for temporary files.

Default value: `'/tmp'`

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.
The install class will not create the user for you. You must do that yourself.
The default value is: `oracle`

Default value: `'oracle'`

##### <a name="version"></a>`version`

Data type: `Ora_install::ShortVersion`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: `'11.2'`

##### <a name="listener_name"></a>`listener_name`

Data type: `String[1]`

The name of the listener process.
The default value is: `listener`

Default value: `'listener'`

### <a name="ora_installopatchupgrade"></a>`ora_install::opatchupgrade`

ora_install::opatchupgrade

For `opatchupgrade` you need to provide the Oracle support csi_number and supportId and need to be online. Or leave them empty but it needs the Expect rpm to emulate OCM.

Here is an example on how to use this:

```puppet
ora_install::opatchupgrade{'112000_opatch_upgrade':
  oracle_home               => '/oracle/product/11.2/db',
  patch_file                => 'p6880880_112000_Linux-x86-64.zip',
  csi_number                => '11111',
  support_id                => 'john.doe@gmail.com',
  csi_number                => undef,
  support_id                => undef,
  opversion                 => '11.2.0.3.6',
  user                      => 'oracle',
  group                     => 'dba',
  download_dir              => '/install',
  puppet_download_mnt_point => 'puppet:///modules/software',
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `ora_install::opatchupgrade` defined type:

* [`csi_number`](#csi_number)
* [`download_dir`](#download_dir)
* [`group`](#group)
* [`logoutput`](#logoutput)
* [`opversion`](#opversion)
* [`oracle_home`](#oracle_home)
* [`patch_file`](#patch_file)
* [`puppet_download_mnt_point`](#puppet_download_mnt_point)
* [`support_id`](#support_id)
* [`umask`](#umask)
* [`user`](#user)
* [`allow_insecure`](#allow_insecure)

##### <a name="csi_number"></a>`csi_number`

Data type: `Optional[Integer]`

The Customer Service Identification number.
This is used to generate an OCMRF file.

Default value: ``undef``

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `'/install'`

##### <a name="group"></a>`group`

Data type: `String[1]`

The os group to use for these Oracle puppet definitions.
The default value is: `dba`

Default value: `'dba'`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Boolean,Enum['on_failure']]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup( { name => 'logoutput', default_value => 'on_failure' })`

##### <a name="opversion"></a>`opversion`

Data type: `String[1]`

The version of Opatch you want to install.

Default value: ``undef``

##### <a name="oracle_home"></a>`oracle_home`

Data type: `Stdlib::Absolutepath`

A directory to be used as Oracle home directory for this software.

Default value: ``undef``

##### <a name="patch_file"></a>`patch_file`

Data type: `String[1]`

The zip file containing the Opatch utility.

Default value: ``undef``

##### <a name="puppet_download_mnt_point"></a>`puppet_download_mnt_point`

Data type: `Optional[String[1]]`

The base path of all remote files for the defined type or class.
The default value is: `puppet:///modules/ora_install`

Default value: ``undef``

##### <a name="support_id"></a>`support_id`

Data type: `Optional[String[1]]`

Your support ID.
This is used to generate an OCMRF file.

Default value: ``undef``

##### <a name="umask"></a>`umask`

Data type: `String[1]`

The umask to use for commands that run in the context of either the grid user or the oracle user.
The default is `0022`

Default value: `'0022'`

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.
The install class will not create the user for you. You must do that yourself.
The default value is: `oracle`

Default value: `'oracle'`

##### <a name="allow_insecure"></a>`allow_insecure`

Data type: `Boolean`

When set to `true` Ignore HTTPS certificate errors
(default: false)

Default value: `lookup( { name => 'allow_insecure', default_value => false })`

### <a name="ora_installprepareautostart_for"></a>`ora_install::prepareautostart_for`

ora_install::prepareautostart_for

This defined creates the script needed to start the database after a system reboot. It supports both `systemd` and the older startup scripts.

Here is an example on how to use it:

```puppet
  ora_install::prepareautostart_for {'DB1':
    oracle_home  => '/oracle/db1',
    user         => 'oracle',
    service_name => 'start_db1',
  }
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `ora_install::prepareautostart_for` defined type:

* [`oracle_home`](#oracle_home)
* [`user`](#user)
* [`group`](#group)
* [`limits`](#limits)
* [`logoutput`](#logoutput)
* [`systemd_template`](#systemd_template)
* [`systemd_template_vars`](#systemd_template_vars)

##### <a name="oracle_home"></a>`oracle_home`

Data type: `String[1]`

A directory to be used as Oracle home directory for this software.

Default value: ``undef``

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.
The install class will not create the user for you. You must do that yourself.
The default value is: `oracle`

Default value: `'oracle'`

##### <a name="group"></a>`group`

Data type: `String[1]`

The os group to use for these Oracle puppet definitions.
The default value is: `dba`

Default value: `'dba'`

##### <a name="limits"></a>`limits`

Data type: `Optional[Hash]`

The limits for the systemd service.
The default value is: undef
Below is an axample. Currently only the 'hard' values are used.
```yaml
ora_install::autostartdatabase::limits:
  '*/nofile':
    soft: 2048
    hard: 8192
  'oracle/nofile':
    soft: 65536
    hard: 65536
  'oracle/nproc':
    soft: 2048
    hard: 16384
  'oracle/stack':
    soft: 10240
    hard: 32768
```

Default value: ``undef``

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Boolean,Enum['on_failure']]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup( { name => 'logoutput', default_value => 'on_failure' })`

##### <a name="systemd_template"></a>`systemd_template`

Data type: `Optional[String[1]]`

Use custom EPP template for systemd service
The default value is: undef

Default value: ``undef``

##### <a name="systemd_template_vars"></a>`systemd_template_vars`

Data type: `Optional[Hash]`

The variables to use when specifying a custom EPP template for systemd service
The default value is: undef

Default value: ``undef``

### <a name="ora_installrcu"></a>`ora_install::rcu`

ora_install::rcu

## Creating a repository

Using this defined class, you can create repositories for several Oracle products. Here are some examples.

Here is an example on how to use it:

### SOA suite repository

```puppet
ora_install::rcu{'install_SOA_v11.1.1.9.0':
  rcu_file                  => 'V75907-01.zip',
  product                   => 'soasuite',
  version                   => '11.1.1.9.0',
  oracle_home               => '/u01/app/oracle/product/11.2.0.4/db_home1',
  user                      => 'oracle',
  group                     => 'dba',
  download_dir              => '/install',
  action                    => 'create',
  db_server                 => 'asm112.example.com:1521',
  db_service                => 'DB112.domain.local',
  sys_password              => 'Welcome01',
  schema_prefix             => 'DEV',
  repos_password            => 'Welcome02',
  puppet_download_mnt_point => 'puppet:///modules/software',
}
```

### webcenter repository

```puppet
ora_install::rcu{'install_WebCenter_11.1.1.7':
  rcu_file                  => 'ofm_rcu_linux_11.1.1.7.0_32_disk1_1of1.zip',
  product                   => 'webcenter',
  version                   => '11.1.1.7',
  oracle_home               => '/u01/app/oracle/product/11.2.0.4/db_home1',
  user                      => 'oracle',
  group                     => 'dba',
  download_dir              => '/install',
  action                    => 'create',
  db_server                 => 'asm112.example.com:1521',
  db_service                => 'DB112.domain.local',
  sys_password              => 'Welcome01',
  schema_prefix             => 'DEV',
  temp_tablespace           => 'TEMP',
  repos_password            => 'Welcome02',
  puppet_download_mnt_point => 'puppet:///modules/software',
}
```

### OIM, OAM repository

OIM needs an Oracle Enterprise Edition database

```puppet
ora_install::rcu{'install_OIM_11.1.2.1':
  rcu_file                  => 'V37476-01.zip',
  product                   => 'oim',
  version                   => '11.1.2.1',
  oracle_home               => '/u01/app/oracle/product/11.2.0.4/db_home1',
  user                      => 'oracle',
  group                     => 'dba',
  download_dir              => '/data/install',
  action                    => 'create',
  db_server                 => 'asm112.example.com:1521',
  db_service                => 'DB112.domain.local',
  sys_password              => 'Welcome01',
  schema_prefix             => 'DEV',
  repos_password            => 'Welcome02',
  puppet_download_mnt_point => 'puppet:///modules/software',
  logoutput                 => true,
 }
```

## deleting a repository

You can also use this defined type to delete a repository. To do so, you need te specify `delete` as action.

Here is an example:

```puppet
ora_install::rcu{'delete_SOA_11.1.1.6':
  rcu_file          => 'ofm_rcu_linux_11.1.1.6.0_disk1_1of1.zip',
  product           => 'soasuite',
  version           => '11.1.1.6',
  oracle_home       => '/oracle/product/11.2/db',
  user              => 'oracle',
  group             => 'dba',
  download_dir      => '/install',
  action            => 'delete',
  db_server         => 'asm112.example.com:1521',
  db_service        => 'DB112.domain.local',
  sys_password      => 'Welcome01',
  schema_prefix     => 'DEV',
  repos_password    => 'Welcome02',
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `ora_install::rcu` defined type:

* [`action`](#action)
* [`db_server`](#db_server)
* [`db_service`](#db_service)
* [`download_dir`](#download_dir)
* [`group`](#group)
* [`logoutput`](#logoutput)
* [`oracle_home`](#oracle_home)
* [`product`](#product)
* [`puppet_download_mnt_point`](#puppet_download_mnt_point)
* [`rcu_file`](#rcu_file)
* [`repos_password`](#repos_password)
* [`schema_prefix`](#schema_prefix)
* [`sys_password`](#sys_password)
* [`sys_user`](#sys_user)
* [`temp_tablespace`](#temp_tablespace)
* [`user`](#user)
* [`version`](#version)
* [`allow_insecure`](#allow_insecure)

##### <a name="action"></a>`action`

Data type: `Enum['create','delete']`

The action to perform.
Valid actions are:
- `create`
- `delete`
The default value is: `create`

Default value: `'create'`

##### <a name="db_server"></a>`db_server`

Data type: `String[1]`

The name of the database server to use.

Default value: ``undef``

##### <a name="db_service"></a>`db_service`

Data type: `String[1]`

The name of the database service to use.

Default value: ``undef``

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `'/install'`

##### <a name="group"></a>`group`

Data type: `String[1]`

The os group to use for these Oracle puppet definitions.
The default value is: `dba`

Default value: `'dba'`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Boolean,Enum['on_failure']]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup( { name => 'logoutput', default_value => 'on_failure' })`

##### <a name="oracle_home"></a>`oracle_home`

Data type: `Optional[Stdlib::Absolutepath]`

A directory to be used as Oracle home directory for this software.

Default value: ``undef``

##### <a name="product"></a>`product`

Data type: `Enum['soasuite','webcenter','oam','oim','all']`

The name of the product for which you want to install the RCU.
The following strings are supported as product:
- `soasuite`
- `webcenter`
- `oam`
- `oim`
- `all`
The default value is: `soasuite`

Default value: `'soasuite'`

##### <a name="puppet_download_mnt_point"></a>`puppet_download_mnt_point`

Data type: `Optional[String[1]]`

The base path of all remote files for the defined type or class.
The default value is: `puppet:///modules/ora_install`

Default value: ``undef``

##### <a name="rcu_file"></a>`rcu_file`

Data type: `String[1]`

The file containing the RCU definition.

Default value: ``undef``

##### <a name="repos_password"></a>`repos_password`

Data type: `Easy_type::Password`

The password for the repo user.

##### <a name="schema_prefix"></a>`schema_prefix`

Data type: `String[1]`

The prefix name to use for the schema.

Default value: ``undef``

##### <a name="sys_password"></a>`sys_password`

Data type: `Easy_type::Password`

The password of the `SYS` user on the database.

##### <a name="sys_user"></a>`sys_user`

Data type: `String[1]`

The name of the `SYS` user on the database.
The default value is: `sys`

Default value: `'sys'`

##### <a name="temp_tablespace"></a>`temp_tablespace`

Data type: `Optional[String[1]]`

Create a temporary tablespace with this name.

Default value: ``undef``

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.
The install class will not create the user for you. You must do that yourself.
The default value is: `oracle`

Default value: `'oracle'`

##### <a name="version"></a>`version`

Data type: `String[1]`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: `'11.1.1.7'`

##### <a name="allow_insecure"></a>`allow_insecure`

Data type: `Boolean`

When set to `true` Ignore HTTPS certificate errors
(default: false)

Default value: `lookup( { name => 'allow_insecure', default_value => false })`

### <a name="ora_installtnsnames"></a>`ora_install::tnsnames`

ora_install::tnsnames

ora` file.

Here is an examples on how to use this:

```puppet
ora_install::tnsnames{'entry':
  oracle_home          => '/u01/app/oracle/product/12.2.0.1/db_home1',
  user                 => 'oracle',
  group                => 'dba',
  server               => { myserver1 => { host => DB122a.example.nl, port => '1521', protocol => 'TCP' },
                            myserver2 => { host => DB122b.example.nl, port => '1521', protocol => 'TCP' }},
  connect_service_name => 'DB122.domain.local',
  connect_server       => 'DEDICATED',
  entry_type           => 'tnsname',
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `ora_install::tnsnames` defined type:

* [`connect_server`](#connect_server)
* [`connect_service_name`](#connect_service_name)
* [`entry_type`](#entry_type)
* [`failover`](#failover)
* [`group`](#group)
* [`},`](#},)
* [`oracle_home`](#oracle_home)
* [`server`](#server)
* [`user`](#user)
* [`sid`](#sid)
* [`loadbalance`](#loadbalance)

##### <a name="connect_server"></a>`connect_server`

Data type: `String[1]`

The name of the server to connect to.

Default value: `'DEDICATED'`

##### <a name="connect_service_name"></a>`connect_service_name`

Data type: `Optional[String[1]]`

The name of the service to connect to.

Default value: ``undef``

##### <a name="entry_type"></a>`entry_type`

Data type: `Enum['tnsname','listener']`

The type of entry to manage.
You can manage the next type of entries:
- `tnsname`
- `listener`
The default value is: `tnsname`

Default value: `'tnsname'`

##### <a name="failover"></a>`failover`

Data type: `String[1]`

Failover ON or OFF.
Valid values are:
- `ON`
- `OFF`
The default value is: `ON`

Default value: `'ON'`

##### <a name="group"></a>`group`

Data type: `String[1]`

The os group to use for these Oracle puppet definitions.
The default value is: `dba`

Default value: `'dba'`

##### <a name="},"></a>`},`

Data type: `port=>'1521', protocol=>'TCP'`

String[1]] loadbalance
Load balance ON or OFF.
Valid values are:
- `ON`
- `OFF`
The default value is: `ON`

##### <a name="oracle_home"></a>`oracle_home`

Data type: `Stdlib::Absolutepath`

A directory to be used as Oracle home directory for this software.

Default value: ``undef``

##### <a name="server"></a>`server`

Data type: `Hash`

A Hash defining the server entry.
The default value is:
```
{myserver => { host => undef, port => '1521', protocol => 'TCP' }}
```

Default value: `{ myserver => { host => undef, port => '1521', protocol => 'TCP' } }`

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.
The install class will not create the user for you. You must do that yourself.
The default value is: `oracle`

Default value: `'oracle'`

##### <a name="sid"></a>`sid`

Data type: `Optional[String[1]]`

The database SID to use.

Default value: ``undef``

##### <a name="loadbalance"></a>`loadbalance`

Data type: `String[1]`



Default value: `'ON'`

### <a name="ora_installutilsdborainst"></a>`ora_install::utils::dborainst`

ora_install::utils::dborainst

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `ora_install::utils::dborainst` defined type:

* [`ora_inventory_dir`](#ora_inventory_dir)
* [`os_group`](#os_group)
* [`os_user`](#os_user)

##### <a name="ora_inventory_dir"></a>`ora_inventory_dir`

Data type: `Stdlib::Absolutepath`

The directory that contains the oracle inventory.
The default value is: `/oracle_base/oraInventory`

Default value: ``undef``

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The OS group to apply to the created directories.

Default value: ``undef``

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The OS user to apply to the created directories.

Default value: ``undef``

## Resource types

### <a name="db_control"></a>`db_control`

control the database instance state like running,stop,restart

#### Properties

The following properties are available in the `db_control` type.

##### `ensure`

Valid values: `start`, `stop`, `running`, `abort`, `stopped`

Aliases: `"running"=>"start", "abort"=>"stop", "stopped"=>"stop"`

Whether to do something.

#### Parameters

The following parameters are available in the `db_control` type.

* [`db_type`](#db_type)
* [`grid_product_home_dir`](#grid_product_home_dir)
* [`instance_name`](#instance_name)
* [`name`](#name)
* [`oracle_product_home_dir`](#oracle_product_home_dir)
* [`os_user`](#os_user)
* [`provider`](#provider)
* [`refreshonly`](#refreshonly)

##### <a name="db_type"></a>`db_type`

Valid values: `database`, `asm`, `grid`

Aliases: `"grid"=>"asm"`

The type of instance.

Default value: `database`

##### <a name="grid_product_home_dir"></a>`grid_product_home_dir`

The grid product home folder.

##### <a name="instance_name"></a>`instance_name`

The database instance name.

##### <a name="name"></a>`name`

namevar

The title.

##### <a name="oracle_product_home_dir"></a>`oracle_product_home_dir`

The oracle product home folder.

##### <a name="os_user"></a>`os_user`

The operating system user.

##### <a name="provider"></a>`provider`

The specific backend to use for this `db_control` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

##### <a name="refreshonly"></a>`refreshonly`

Valid values: ``true``, ``false``

The command should only be run as a
refresh mechanism for when a dependent object is changed.

Default value: ``false``

### <a name="db_directory_structure"></a>`db_directory_structure`

add all the directories needed by the oracle db or asm installation

#### Properties

The following properties are available in the `db_directory_structure` type.

##### `ensure`

Valid values: `present`

Whether to do something.

#### Parameters

The following parameters are available in the `db_directory_structure` type.

* [`create_orainst_only`](#create_orainst_only)
* [`download_dir`](#download_dir)
* [`name`](#name)
* [`ora_inventory_dir`](#ora_inventory_dir)
* [`oracle_base_dir`](#oracle_base_dir)
* [`os_group`](#os_group)
* [`os_user`](#os_user)
* [`provider`](#provider)

##### <a name="create_orainst_only"></a>`create_orainst_only`

Valid values: ``true``, ``false``

Only create oraInst.loc file.

Default value: ``false``

##### <a name="download_dir"></a>`download_dir`

The download folder.

##### <a name="name"></a>`name`

namevar

The title.

##### <a name="ora_inventory_dir"></a>`ora_inventory_dir`

The oracle inventory folder.

##### <a name="oracle_base_dir"></a>`oracle_base_dir`

The oracle base folder.

##### <a name="os_group"></a>`os_group`

The operating system group.

Default value: `oinstall`

##### <a name="os_user"></a>`os_user`

The operating system user.

Default value: `oracle`

##### <a name="provider"></a>`provider`

The specific backend to use for this `db_directory_structure` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="db_listener"></a>`db_listener`

control the oracle db listener state like running,stop,restart

#### Parameters

The following parameters are available in the `db_listener` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `db_listener` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="db_opatch"></a>`db_opatch`

This is the Oracle Patch process called OPatch

#### Properties

The following properties are available in the `db_opatch` type.

##### `ensure`

Valid values: `present`, `absent`, `installed`, `purged`

Aliases: `"installed"=>"present", "purged"=>"absent"`

Whether a patch should be applied.

#### Parameters

The following parameters are available in the `db_opatch` type.

* [`bundle_sub_patch_id`](#bundle_sub_patch_id)
* [`extracted_patch_dir`](#extracted_patch_dir)
* [`name`](#name)
* [`ocmrf_file`](#ocmrf_file)
* [`opatch_auto`](#opatch_auto)
* [`oracle_product_home_dir`](#oracle_product_home_dir)
* [`orainst_dir`](#orainst_dir)
* [`os_user`](#os_user)
* [`patch_id`](#patch_id)
* [`provider`](#provider)

##### <a name="bundle_sub_patch_id"></a>`bundle_sub_patch_id`

One of the Sub patch number of the bundle patch

##### <a name="extracted_patch_dir"></a>`extracted_patch_dir`

The extracted patch folder.

##### <a name="name"></a>`name`

namevar

The name of the OPatch.

##### <a name="ocmrf_file"></a>`ocmrf_file`

The ocmrf file.

##### <a name="opatch_auto"></a>`opatch_auto`

opatch auto bundle patch

##### <a name="oracle_product_home_dir"></a>`oracle_product_home_dir`

The oracle product home folder.

##### <a name="orainst_dir"></a>`orainst_dir`

The orainst folder.

##### <a name="os_user"></a>`os_user`

The weblogic operating system user.

##### <a name="patch_id"></a>`patch_id`

The patchId of the OPatch.

##### <a name="provider"></a>`provider`

The specific backend to use for this `db_opatch` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

### <a name="db_rcu"></a>`db_rcu`

This is the Oracle RCU ( Repository creation utility) installer type

#### Properties

The following properties are available in the `db_rcu` type.

##### `ensure`

Valid values: `present`, `absent`, `create`, `delete`

Aliases: `"create"=>"present", "delete"=>"absent"`

Whether a Repository should be created.

#### Parameters

The following parameters are available in the `db_rcu` type.

* [`db_server`](#db_server)
* [`db_service`](#db_service)
* [`name`](#name)
* [`oracle_home`](#oracle_home)
* [`os_user`](#os_user)
* [`provider`](#provider)
* [`statement`](#statement)
* [`sys_password`](#sys_password)
* [`sys_user`](#sys_user)

##### <a name="db_server"></a>`db_server`

The database server for the RCU check/install.

##### <a name="db_service"></a>`db_service`

The database service for the RCU check/install.

##### <a name="name"></a>`name`

namevar

The prefix of the RCU.

##### <a name="oracle_home"></a>`oracle_home`

The oracle database home folder.

##### <a name="os_user"></a>`os_user`

The weblogic operating system user.

##### <a name="provider"></a>`provider`

The specific backend to use for this `db_rcu` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

##### <a name="statement"></a>`statement`

The RCU statement.

##### <a name="sys_password"></a>`sys_password`

The sys password for the RCU check/install.

##### <a name="sys_user"></a>`sys_user`

The sys username for the RCU check/install.

### <a name="ora_home"></a>`ora_home`

This resource allows you to manage Oracle homes.

#### Properties

The following properties are available in the `ora_home` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_home` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_home` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

### <a name="ora_install"></a>`ora_install`

Start the setup for applying ora_install classes.

#### Properties

The following properties are available in the `ora_install` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_install` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_install` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="ora_opatch"></a>`ora_opatch`

This resource allows you to manage opatch patches on a specific database home.

#### Parameters

The following parameters are available in the `ora_opatch` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_opatch` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

### <a name="ora_tab_entry"></a>`ora_tab_entry`

With this type you can manage entries in the systems oratab file.

Here is an example on how to use this:

  ora_tab_entry { 'MYDB':
      ensure      => 'present',
      comment     => 'My own database',
      oracle_home => '/u01/app/oracle/product/12.2.0.1/db_home1',
      startup     => 'Y',
    }

#### Properties

The following properties are available in the `ora_tab_entry` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `ora_tab_entry` type.

* [`provider`](#provider)

##### <a name="provider"></a>`provider`

The specific backend to use for this `ora_tab_entry` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

## Functions

### <a name="opatch_version"></a>`opatch_version`

Type: Ruby 4.x API

See the file "LICENSE" for the full license governing this code.

Returns the the installed Opatch version for a specfied Oracle home

#### `opatch_version(String $oracle_home)`

See the file "LICENSE" for the full license governing this code.

Returns the the installed Opatch version for a specfied Oracle home

Returns: `String`

##### `oracle_home`

Data type: `String`



### <a name="ora_installchanged_oracle_home_for"></a>`ora_install::changed_oracle_home_for`

Type: Ruby 4.x API

See the file "LICENSE" for the full license governing this code.


This function checks if the specified home, is the current home for the
specified SID.

#### `ora_install::changed_oracle_home_for(String[1] $sid, String[1] $oracle_home)`

See the file "LICENSE" for the full license governing this code.


This function checks if the specified home, is the current home for the
specified SID.

Returns: `Variant[Boolean, Undef]`

##### `sid`

Data type: `String[1]`



##### `oracle_home`

Data type: `String[1]`



### <a name="ora_installopatch_version"></a>`ora_install::opatch_version`

Type: Ruby 4.x API

See the file "LICENSE" for the full license governing this code.

Returns the the installed Opatch version for a specfied Oracle home

#### `ora_install::opatch_version(String $oracle_home)`

See the file "LICENSE" for the full license governing this code.

Returns the the installed Opatch version for a specfied Oracle home

Returns: `String`

##### `oracle_home`

Data type: `String`



### <a name="ora_installora_patches_installed"></a>`ora_install::ora_patches_installed`

Type: Ruby 4.x API

See the file "LICENSE" for the full license governing this code.


This function checks if the specfied patches are installed.
The patch list is an array and has the syntax

   ['/oracle/home/dir:patchid']

It will check all registered Oracle homes for the installed patches.

#### `ora_install::ora_patches_installed(Array $patch_list)`

See the file "LICENSE" for the full license governing this code.


This function checks if the specfied patches are installed.
The patch list is an array and has the syntax

   ['/oracle/home/dir:patchid']

It will check all registered Oracle homes for the installed patches.

Returns: `Boolean`

##### `patch_list`

Data type: `Array`



### <a name="ora_installora_patches_missing"></a>`ora_install::ora_patches_missing`

Type: Ruby 4.x API

See the file "LICENSE" for the full license governing this code.


This function checks if the specfied patches are installed.
For type = db (default) the function will return a hash with all homes and their patch details
  that needs at least one patch installed.
For type = grid the function will return a hash with only patches that haven't been installed yet.
  There is a difference because of the way patches are applied for grid, opatchauto vs regular provider.

It will check all registered Oracle homes for the installed patches.

#### `ora_install::ora_patches_missing(Hash $patch_list, Optional[Enum['db','grid']] $type)`

See the file "LICENSE" for the full license governing this code.


This function checks if the specfied patches are installed.
For type = db (default) the function will return a hash with all homes and their patch details
  that needs at least one patch installed.
For type = grid the function will return a hash with only patches that haven't been installed yet.
  There is a difference because of the way patches are applied for grid, opatchauto vs regular provider.

It will check all registered Oracle homes for the installed patches.

Returns: `Hash`

##### `patch_list`

Data type: `Hash`



##### `type`

Data type: `Optional[Enum['db','grid']]`



### <a name="ora_installora_physical_patches"></a>`ora_install::ora_physical_patches`

Type: Ruby 4.x API

See the file "LICENSE" for the full license governing this code.


This function parses a Hash of patches and looks for resources with
sub_patches. If they are there, this function will translate it to the
actual list of patches that need to be on the system.

#### `ora_install::ora_physical_patches(Hash $patch_list)`

See the file "LICENSE" for the full license governing this code.


This function parses a Hash of patches and looks for resources with
sub_patches. If they are there, this function will translate it to the
actual list of patches that need to be on the system.

Returns: `Array`

##### `patch_list`

Data type: `Hash`



### <a name="ora_installoracle_exists"></a>`ora_install::oracle_exists`

Type: Ruby 4.x API

The ora_install::oracle_exists function.

#### `ora_install::oracle_exists(String $oracle_home)`

The ora_install::oracle_exists function.

Returns: `Boolean`

##### `oracle_home`

Data type: `String`



### <a name="ora_patches_installed"></a>`ora_patches_installed`

Type: Ruby 4.x API

See the file "LICENSE" for the full license governing this code.


This function checks if the specfied patches are installed.
The patch list is an array and has the syntax

   ['/oracle/home/dir:patchid']

It will check all registered Oracle homes for the installed patches.

#### `ora_patches_installed(Array $patch_list)`

See the file "LICENSE" for the full license governing this code.


This function checks if the specfied patches are installed.
The patch list is an array and has the syntax

   ['/oracle/home/dir:patchid']

It will check all registered Oracle homes for the installed patches.

Returns: `Boolean`

##### `patch_list`

Data type: `Array`



### <a name="ora_physical_patches"></a>`ora_physical_patches`

Type: Ruby 4.x API

See the file "LICENSE" for the full license governing this code.


This function parses a Hash of patches and looks for resources with
sub_patches. If they are there, this function will translate it to the
actual list of patches that need to be on the system.

#### `ora_physical_patches(Hash $patch_list)`

See the file "LICENSE" for the full license governing this code.


This function parses a Hash of patches and looks for resources with
sub_patches. If they are there, this function will translate it to the
actual list of patches that need to be on the system.

Returns: `Array`

##### `patch_list`

Data type: `Hash`



### <a name="oracle_exists"></a>`oracle_exists`

Type: Ruby 4.x API

The oracle_exists function.

#### `oracle_exists(String $oracle_home)`

The oracle_exists function.

Returns: `Boolean`

##### `oracle_home`

Data type: `String`



## Data types

### <a name="ora_installdatabaseversion"></a>`Ora_install::DatabaseVersion`

The Ora_install::DatabaseVersion data type.

Alias of

```puppet
Enum['ORA11g', 'ORA12c', 'ORA18c', 'ORA19c']
```

### <a name="ora_installshortversion"></a>`Ora_install::ShortVersion`

The Ora_install::ShortVersion data type.

Alias of

```puppet
Enum['11.2', '12.1', '12.2', '18.0', '19.0', '21.0']
```

### <a name="ora_installversion"></a>`Ora_install::Version`

The Ora_install::Version data type.

Alias of

```puppet
Enum['11.2.0.1', '11.2.0.3', '11.2.0.4', '12.1.0.1', '12.1.0.2', '12.2.0.1', '18.0.0.0', '19.0.0.0', '21.0.0.0']
```

## Tasks

### <a name="agent_action"></a>`agent_action`

Enable, disable or start a puppet agent run.

**Supports noop?** false

#### Parameters

##### `action`

Data type: `Enum['enable','disable','run']`

The action to do on the agent.

##### `comment`

Data type: `Optional[String[1]]`

The comment to use when disabling puppet runs.

##### `verbose`

Data type: `Optional[Enum['debug', 'info', 'notice', 'warning', 'err', 'alert', 'emerg', 'crit']]`

The level of verbosity to use.

##### `format`

Data type: `Optional[Enum['pretty','json']]`

Format of the output.

### <a name="apply_psu_db"></a>`apply_psu_db`

Execute the PSU database update for specified SID.

**Supports noop?** false

#### Parameters

##### `sid`

Data type: `String[1,8]`

SID of the database to connect to.

##### `verbose`

Data type: `Optional[Enum['debug', 'info', 'notice', 'warning', 'err', 'alert', 'emerg', 'crit']]`

The level of verbosity to use.

##### `format`

Data type: `Optional[Enum['pretty','json']]`

Format of the output.

### <a name="db_action"></a>`db_action`

Execute an action pn the specified Oracle instance

**Supports noop?** false

#### Parameters

##### `sid`

Data type: `Optional[String[1]]`

SID of the database to connect to

##### `action`

Data type: `Enum['start', 'stop', 'restart']`

The action that needs to be executed on the database

##### `type`

Data type: `Optional[Enum['immediate', 'abort', 'nomount', 'normal', 'mount', 'restrict', 'open', 'open recover', 'upgrade']]`

Type of action

##### `verbose`

Data type: `Optional[Enum['debug', 'info', 'notice', 'warning', 'err', 'alert', 'emerg', 'crit']]`

The level of verbosity to use.

##### `format`

Data type: `Optional[Enum['pretty','json']]`

Format of the output.

### <a name="grid_action"></a>`grid_action`

Execute actions (stop/start) on Oracle Grid installations for patching.

**Supports noop?** false

#### Parameters

##### `action`

Data type: `Enum['start', 'stop']`

The action that needs to be executed

##### `verbose`

Data type: `Optional[Enum['debug', 'info', 'notice', 'warning', 'err', 'alert', 'emerg', 'crit']]`

The level of verbosity to use.

##### `format`

Data type: `Optional[Enum['pretty','json']]`

Format of the output.

### <a name="listener_action"></a>`listener_action`

Execute an action on the Oracle listener

**Supports noop?** false

#### Parameters

##### `sid`

Data type: `Optional[String[1]]`

SID of the database the listener is running for

##### `action`

Data type: `Enum['start', 'stop', 'restart']`

The action that needs to be executed on the database

##### `listener_name`

Data type: `Optional[String[1]]`

Name of the listener

##### `verbose`

Data type: `Optional[Enum['debug', 'info', 'notice', 'warning', 'err', 'alert', 'emerg', 'crit']]`

The level of verbosity to use.

##### `format`

Data type: `Optional[Enum['pretty','json']]`

Format of the output.

### <a name="opatch_upgrade"></a>`opatch_upgrade`

Apply patch(es) to an Oracle home.

**Supports noop?** false

#### Parameters

##### `oracle_home`

Data type: `String[1]`

The Oracle home to patch.

##### `patch_file`

Data type: `Optional[String[1]]`

The file needed to upgrade OPatch.

##### `opatch_version`

Data type: `Optional[String[1]]`

The version of OPatch to install.

##### `patch_list`

Data type: `Hash`

The list of patches to apply.

##### `source`

Data type: `String[1]`

The location where the patch files can be found.

##### `verbose`

Data type: `Optional[Enum['debug', 'info', 'notice', 'warning', 'err', 'alert', 'emerg', 'crit']]`

The level of verbosity to use.

##### `format`

Data type: `Optional[Enum['pretty','json']]`

Format of the output.

### <a name="restart"></a>`restart`

Restart the specified Oracle instance on the specified node

**Supports noop?** false

#### Parameters

##### `sid`

Data type: `Optional[String[1]]`

SID of the database to connect to

##### `shutdown_type`

Data type: `Optional[Enum['abort', 'immediate', 'normal', 'transactional', 'transactional local']]`

Type of shutdown

##### `startup_type`

Data type: `Optional[Enum['nomount', 'mount', 'restrict', 'open recover']]`

Type of startup

### <a name="shutdown"></a>`shutdown`

Shutdown the specified Oracle instance on the specified node

**Supports noop?** false

#### Parameters

##### `sid`

Data type: `Optional[String[1]]`

SID of the database to connect to

##### `type`

Data type: `Optional[Enum['abort', 'immediate', 'normal', 'transactional', 'transactional local']]`

Type of shutdown

##### `verbose`

Data type: `Optional[Enum['debug', 'info', 'notice', 'warning', 'err', 'alert', 'emerg', 'crit']]`

The level of verbosity to use.

##### `planned`

Data type: `Optional[Boolean]`

Task is part of plan.

### <a name="startup"></a>`startup`

Startup the specified Oracle instance on the specified node

**Supports noop?** false

#### Parameters

##### `sid`

Data type: `Optional[String[1]]`

SID of the database to connect to

##### `type`

Data type: `Optional[Enum['nomount', 'mount', 'restrict', 'open recover', 'upgrade']]`

Type of shutdown

##### `verbose`

Data type: `Optional[Enum['debug', 'info', 'notice', 'warning', 'err', 'alert', 'emerg', 'crit']]`

The level of verbosity to use.

##### `format`

Data type: `Optional[Enum['pretty','json']]`

Format of the output.

### <a name="switch_grid_home"></a>`switch_grid_home`

Switch a running instance to an other already available Oracle home.

**Supports noop?** false

#### Parameters

##### `sid`

Data type: `Optional[String[1,8]]`

SID of the database to connect to.

##### `verbose`

Data type: `Optional[Enum['debug', 'info', 'notice', 'warning', 'err', 'alert', 'emerg', 'crit']]`

The level of verbosity to use.

##### `new_home`

Data type: `String[1]`

The new Oracle home for the sid.

##### `format`

Data type: `Optional[Enum['pretty','json']]`

Format of the output.

### <a name="switch_oracle_home"></a>`switch_oracle_home`

Switch a running instance to an other already available Oracle home.

**Supports noop?** false

#### Parameters

##### `sid`

Data type: `String[1,8]`

SID of the database to connect to.

##### `verbose`

Data type: `Optional[Enum['debug', 'info', 'notice', 'warning', 'err', 'alert', 'emerg', 'crit']]`

The level of verbosity to use.

##### `new_home`

Data type: `String[1]`

The new Oracle home for the sid.

##### `format`

Data type: `Optional[Enum['pretty','json']]`

Format of the output.

### <a name="upgrade_db"></a>`upgrade_db`

Execute the database upgrade for specified SID.

**Supports noop?** false

#### Parameters

##### `sid`

Data type: `String[1,8]`

SID of the database to connect to.

## Plans

### <a name="ora_installinstall_grid_home_and_patch"></a>`ora_install::install_grid_home_and_patch`

See the file "LICENSE" for the full license governing this code.

#### Examples

##### 

```puppet
bolt plan run ora_install::install_grid_home_and_patch -t localhost version=19.0.0.0 file=LINUX.X64_193000_grid_home grid_type=HA_SWONLY grid_base=/u01/app/grid/admin grid_home=/u01/app/grid/product/19.0.0.0/grid_home2 ora_inventory_dir=/u01/app puppet_download_mnt_point=/nfs_share/software sys_asm_password=secret asm_monitor_password=secret patch_file=p6880880_190000_Linux-x86-64.zip opversion=12.2.0.1.17 patch_list='{"/u01/app/grid/product/19.0.0.0/grid_home2:30116789": {"source": "/nfs_share/software/p30116789_190000_Linux-x86-64.zip", "sub_patches": ["30125133","30122149","30122167","29401763"]}}'
```

#### Parameters

The following parameters are available in the `ora_install::install_grid_home_and_patch` plan:

* [`dbserver`](#dbserver)
* [`sys_asm_password`](#sys_asm_password)
* [`asm_monitor_password`](#asm_monitor_password)
* [`version`](#version)
* [`file`](#file)
* [`grid_type`](#grid_type)
* [`stand_alone`](#stand_alone)
* [`grid_base`](#grid_base)
* [`grid_home`](#grid_home)
* [`ora_inventory_dir`](#ora_inventory_dir)
* [`user`](#user)
* [`user_base_dir`](#user_base_dir)
* [`group`](#group)
* [`group_install`](#group_install)
* [`group_oper`](#group_oper)
* [`group_asm`](#group_asm)
* [`download_dir`](#download_dir)
* [`temp_dir`](#temp_dir)
* [`zip_extract`](#zip_extract)
* [`install_task`](#install_task)
* [`puppet_download_mnt_point`](#puppet_download_mnt_point)
* [`dirs`](#dirs)
* [`patch_file`](#patch_file)
* [`csi_number`](#csi_number)
* [`support_id`](#support_id)
* [`opversion`](#opversion)
* [`source`](#source)
* [`patch_list`](#patch_list)
* [`format`](#format)

##### <a name="dbserver"></a>`dbserver`

Data type: `TargetSpec`

The target for this plan.

##### <a name="sys_asm_password"></a>`sys_asm_password`

Data type: `String[1]`

The password to use for the SYSASM user.

##### <a name="asm_monitor_password"></a>`asm_monitor_password`

Data type: `String[1]`

The password for the ASMSNMP user for monitoring in EM.

##### <a name="version"></a>`version`

Data type: `Ora_install::Version`

The version that is installed in the used Oracle home.

Default value: ``undef``

##### <a name="file"></a>`file`

Data type: `String[1]`

The source file to use for the GRID_HOME installation.

Default value: ``undef``

##### <a name="grid_type"></a>`grid_type`

Data type: `Enum['CRS_CONFIG','HA_CONFIG','UPGRADE','CRS_SWONLY','HA_SWONLY']`

The type of grid.

Default value: `'HA_CONFIG'`

##### <a name="stand_alone"></a>`stand_alone`

Data type: `Boolean`

Configuring Grid Infrastructure for a Stand-Alone Server.

Default value: ``true``

##### <a name="grid_base"></a>`grid_base`

Data type: `Stdlib::Absolutepath`

The directory to use as grid base.

Default value: ``undef``

##### <a name="grid_home"></a>`grid_home`

Data type: `Stdlib::Absolutepath`

The directory to use as grid home.

Default value: ``undef``

##### <a name="ora_inventory_dir"></a>`ora_inventory_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The directory that contains the oracle inventory.

Default value: ``undef``

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.

Default value: `'grid'`

##### <a name="user_base_dir"></a>`user_base_dir`

Data type: `Stdlib::Absolutepath`

The directory to use as base directory for the users.

Default value: `'/home'`

##### <a name="group"></a>`group`

Data type: `String[1]`

The os group to use for these Oracle puppet definitions.

Default value: `'asmdba'`

##### <a name="group_install"></a>`group_install`

Data type: `String[1]`

The os group to use for installation.

Default value: `'oinstall'`

##### <a name="group_oper"></a>`group_oper`

Data type: `String[1]`

The OS group to allow ASM oper operations.

Default value: `'asmoper'`

##### <a name="group_asm"></a>`group_asm`

Data type: `String[1]`

The OS group to use.

Default value: `'asmadmin'`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.

Default value: `'/install'`

##### <a name="temp_dir"></a>`temp_dir`

Data type: `Stdlib::Absolutepath`

Directory to use for temporary files.

Default value: `'/tmp'`

##### <a name="zip_extract"></a>`zip_extract`

Data type: `Boolean`

The specified source file is a zip file that needs te be extracted.
When you specify a value of false, the source attribute must contain a reference to a directory instead of a zip file.

Default value: ``true``

##### <a name="install_task"></a>`install_task`

Data type: `Enum['ALL','EXTRACT','SETUP']`

The task the installation should execute.

Default value: `'ALL'`

##### <a name="puppet_download_mnt_point"></a>`puppet_download_mnt_point`

Data type: `Optional[String[1]]`

The base path of all remote files for the defined type or class.

Default value: ``undef``

##### <a name="dirs"></a>`dirs`

Data type: `Optional[Array[Stdlib::Absolutepath]]`

Directories that should be created in this plan. For example the parent directory (tree) of the GRID_HOME.

Default value: `[]`

##### <a name="patch_file"></a>`patch_file`

Data type: `String[1]`

The zip file containing the Opatch utility.

Default value: ``undef``

##### <a name="csi_number"></a>`csi_number`

Data type: `Optional[Integer]`

The Customer Service Identification number.

Default value: ``undef``

##### <a name="support_id"></a>`support_id`

Data type: `Optional[String[1]]`

Your support ID.

Default value: ``undef``

##### <a name="opversion"></a>`opversion`

Data type: `String[1]`

The version of Opatch you want to install.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String[1]]`

The source of the patch. Can be either an extracted folder or the raw zip file.

Default value: ``undef``

##### <a name="patch_list"></a>`patch_list`

Data type: `Hash`

List of patches to apply.

Options:

* **source** `String[1]`: Full path to the zipfile that contains the patch
* **sub_patches** `Array`: List of patch numbers that are part of the patchset

Default value: `{}`

##### <a name="format"></a>`format`

Data type: `Optional[Enum['json','pretty']]`

Specify the format of the output, human readable (pretty) or not (json).

Default value: `'pretty'`

### <a name="ora_installinstall_oracle_home"></a>`ora_install::install_oracle_home`

See the file "LICENSE" for the full license governing this code.

++--++

--++--

#### Examples

##### 

```puppet
bolt plan run ora_install::install_oracle_home -t localhost version=18.0.0.0 file=LINUX.X64_180000_db_home oracle_base=/u01/app/oracle/admin oracle_home=/u01/app/oracle/product/18.0.0.0/db_home2 ora_inventory_dir=/u01/app puppet_download_mnt_point=/nfs_share/software
```

#### Parameters

The following parameters are available in the `ora_install::install_oracle_home` plan:

* [`dbserver`](#dbserver)
* [`version`](#version)
* [`oracle_base`](#oracle_base)
* [`oracle_home`](#oracle_home)
* [`file`](#file)
* [`user`](#user)
* [`group`](#group)
* [`group_install`](#group_install)
* [`group_oper`](#group_oper)
* [`database_type`](#database_type)
* [`download_dir`](#download_dir)
* [`temp_dir`](#temp_dir)
* [`dirs`](#dirs)
* [`cluster_nodes`](#cluster_nodes)
* [`ora_inventory_dir`](#ora_inventory_dir)
* [`puppet_download_mnt_point`](#puppet_download_mnt_point)
* [`format`](#format)

##### <a name="dbserver"></a>`dbserver`

Data type: `TargetSpec`

The target for this plan.

##### <a name="version"></a>`version`

Data type: `Ora_install::Version`

The version that is installed in the used Oracle home.

Default value: ``undef``

##### <a name="oracle_base"></a>`oracle_base`

Data type: `Stdlib::Absolutepath`

A directory to use as Oracle base directory.

Default value: ``undef``

##### <a name="oracle_home"></a>`oracle_home`

Data type: `Stdlib::Absolutepath`

A directory to be used as Oracle home directory for this software.

Default value: ``undef``

##### <a name="file"></a>`file`

Data type: `String[1]`

The source file to use for the ORACLE_HOME installation.

Default value: ``undef``

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.

Default value: `'oracle'`

##### <a name="group"></a>`group`

Data type: `String[1]`

The os group to use for these Oracle puppet definitions.

Default value: `'dba'`

##### <a name="group_install"></a>`group_install`

Data type: `String[1]`

The os group to use for installation.

Default value: `'oinstall'`

##### <a name="group_oper"></a>`group_oper`

Data type: `String[1]`

The OS group to allow operator rights.

Default value: `'oper'`

##### <a name="database_type"></a>`database_type`

Data type: `Enum['SE2', 'SE', 'EE', 'SEONE']`

Selects the type of database you want to install.

Default value: `'EE'`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.

Default value: `'/install'`

##### <a name="temp_dir"></a>`temp_dir`

Data type: `Stdlib::Absolutepath`

Directory to use for temporary files.

Default value: `'/tmp'`

##### <a name="dirs"></a>`dirs`

Data type: `Optional[Array[Stdlib::Absolutepath]]`

Directories that should be created in this plan. For example the parent directory (tree) of the GRID_HOME.

Default value: `[]`

##### <a name="cluster_nodes"></a>`cluster_nodes`

Data type: `Optional[String[1]]`

A comma seperated list of the nodes running in the RAC cluster.

Default value: ``undef``

##### <a name="ora_inventory_dir"></a>`ora_inventory_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The directory that contains the oracle inventory.

Default value: `'/u01/app'`

##### <a name="puppet_download_mnt_point"></a>`puppet_download_mnt_point`

Data type: `Optional[String[1]]`

The base path of all remote files for the defined type or class.

Default value: `'puppet:///modules/software'`

##### <a name="format"></a>`format`

Data type: `Optional[Enum['json','pretty']]`

Specify the format of the output, human readable (pretty) or not (json).

Default value: `'pretty'`

### <a name="ora_installinstall_oracle_home_and_patch"></a>`ora_install::install_oracle_home_and_patch`

See the file "LICENSE" for the full license governing this code.

++--++

#### Examples

##### 

```puppet
bolt plan run ora_install::install_oracle_home_and_patch -t localhost version=18.0.0.0 file=LINUX.X64_180000_db_home oracle_base=/u01/app/oracle/admin oracle_home=/u01/app/oracle/product/18.0.0.0/db_home2 ora_inventory_dir=/u01/app puppet_download_mnt_point=/nfs_share/software patch_file=p6880880_190000_Linux-x86-64.zip opversion=12.2.0.1.17 patch_list='{"/u01/app/oracle/product/18.0.0.0/db_home2:30116795": {"source": "/nfs_share/software/p30116795_180000_Linux-x86-64.zip", "sub_patches": ["30112122","30113775"]}}'
```

#### Parameters

The following parameters are available in the `ora_install::install_oracle_home_and_patch` plan:

* [`dbserver`](#dbserver)
* [`version`](#version)
* [`oracle_base`](#oracle_base)
* [`oracle_home`](#oracle_home)
* [`file`](#file)
* [`user`](#user)
* [`group`](#group)
* [`group_install`](#group_install)
* [`group_oper`](#group_oper)
* [`database_type`](#database_type)
* [`download_dir`](#download_dir)
* [`temp_dir`](#temp_dir)
* [`dirs`](#dirs)
* [`cluster_nodes`](#cluster_nodes)
* [`ora_inventory_dir`](#ora_inventory_dir)
* [`puppet_download_mnt_point`](#puppet_download_mnt_point)
* [`patch_file`](#patch_file)
* [`csi_number`](#csi_number)
* [`support_id`](#support_id)
* [`opversion`](#opversion)
* [`source`](#source)
* [`patch_list`](#patch_list)
* [`format`](#format)

##### <a name="dbserver"></a>`dbserver`

Data type: `TargetSpec`

The target for this plan.

##### <a name="version"></a>`version`

Data type: `Ora_install::Version`

The version that is installed in the used Oracle home.

Default value: ``undef``

##### <a name="oracle_base"></a>`oracle_base`

Data type: `Stdlib::Absolutepath`

A directory to use as Oracle base directory.

Default value: ``undef``

##### <a name="oracle_home"></a>`oracle_home`

Data type: `Stdlib::Absolutepath`

A directory to be used as Oracle home directory for this software.

Default value: ``undef``

##### <a name="file"></a>`file`

Data type: `String[1]`

The source file to use for the ORACLE_HOME installation.

Default value: ``undef``

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.

Default value: `'oracle'`

##### <a name="group"></a>`group`

Data type: `String[1]`

The os group to use for these Oracle puppet definitions.

Default value: `'dba'`

##### <a name="group_install"></a>`group_install`

Data type: `String[1]`

The os group to use for installation.

Default value: `'oinstall'`

##### <a name="group_oper"></a>`group_oper`

Data type: `String[1]`

The OS group to allow operator rights.

Default value: `'oper'`

##### <a name="database_type"></a>`database_type`

Data type: `Enum['SE2', 'SE', 'EE', 'SEONE']`

Selects the type of database you want to install.

Default value: `'EE'`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.

Default value: `'/install'`

##### <a name="temp_dir"></a>`temp_dir`

Data type: `Stdlib::Absolutepath`

Directory to use for temporary files.

Default value: `'/tmp'`

##### <a name="dirs"></a>`dirs`

Data type: `Optional[Array[Stdlib::Absolutepath]]`

Directories that should be created in this plan. For example the parent directory (tree) of the GRID_HOME.

Default value: `[]`

##### <a name="cluster_nodes"></a>`cluster_nodes`

Data type: `Optional[String[1]]`

A comma seperated list of the nodes running in the RAC cluster.

Default value: ``undef``

##### <a name="ora_inventory_dir"></a>`ora_inventory_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The directory that contains the oracle inventory.

Default value: `'/u01/app'`

##### <a name="puppet_download_mnt_point"></a>`puppet_download_mnt_point`

Data type: `Optional[String[1]]`

The base path of all remote files for the defined type or class.

Default value: `'puppet:///modules/software'`

##### <a name="patch_file"></a>`patch_file`

Data type: `String[1]`

The zip file containing the Opatch utility.

Default value: ``undef``

##### <a name="csi_number"></a>`csi_number`

Data type: `Optional[Integer]`

The Customer Service Identification number.

Default value: ``undef``

##### <a name="support_id"></a>`support_id`

Data type: `Optional[String[1]]`

Your support ID.

Default value: ``undef``

##### <a name="opversion"></a>`opversion`

Data type: `String[1]`

The version of Opatch you want to install.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String[1]]`

The source of the patch. Can be either an extracted folder or the raw zip file.

Default value: ``undef``

##### <a name="patch_list"></a>`patch_list`

Data type: `Hash`

List of patches to apply.

Options:

* **source** `String[1]`: Full path to the zipfile that contains the patch
* **sub_patches** `Array`: List of patch numbers that are part of the patchset

Default value: `{}`

##### <a name="format"></a>`format`

Data type: `Optional[Enum['json','pretty']]`

Specify the format of the output, human readable (pretty) or not (json).

Default value: `'pretty'`

### <a name="ora_installopatch_upgrade"></a>`ora_install::opatch_upgrade`

See the file "LICENSE" for the full license governing this code.

++--++

#### Examples

##### 

```puppet
bolt plan run ora_install::opatch_upgrade -t localhost oracle_home=/u01/app/oracle/product/18.0.0.0/db_home2 patch_file=p6880880_190000_Linux-x86-64.zip opversion=12.2.0.1.17 puppet_download_mnt_point=/nfs_share/software
```

#### Parameters

The following parameters are available in the `ora_install::opatch_upgrade` plan:

* [`dbserver`](#dbserver)
* [`oracle_home`](#oracle_home)
* [`patch_file`](#patch_file)
* [`csi_number`](#csi_number)
* [`support_id`](#support_id)
* [`opversion`](#opversion)
* [`user`](#user)
* [`group`](#group)
* [`download_dir`](#download_dir)
* [`puppet_download_mnt_point`](#puppet_download_mnt_point)
* [`format`](#format)

##### <a name="dbserver"></a>`dbserver`

Data type: `TargetSpec`

The target for this plan.

##### <a name="oracle_home"></a>`oracle_home`

Data type: `Stdlib::Absolutepath`

A directory to be used as Oracle home directory for this software.

Default value: ``undef``

##### <a name="patch_file"></a>`patch_file`

Data type: `String[1]`

The zip file containing the Opatch utility.

Default value: ``undef``

##### <a name="csi_number"></a>`csi_number`

Data type: `Optional[Integer]`

The Customer Service Identification number.

Default value: ``undef``

##### <a name="support_id"></a>`support_id`

Data type: `Optional[String[1]]`

Your support ID.

Default value: ``undef``

##### <a name="opversion"></a>`opversion`

Data type: `String[1]`

The version of Opatch you want to install.

Default value: ``undef``

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.

Default value: `'oracle'`

##### <a name="group"></a>`group`

Data type: `String[1]`

The os group to use for these Oracle puppet definitions.

Default value: `'dba'`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.

Default value: `'/install'`

##### <a name="puppet_download_mnt_point"></a>`puppet_download_mnt_point`

Data type: `Optional[String[1]]`

The base path of all remote files for the defined type or class.

Default value: ``undef``

##### <a name="format"></a>`format`

Data type: `Optional[Enum['json','pretty']]`

Specify the format of the output, human readable (pretty) or not (json).

Default value: `'pretty'`

### <a name="ora_installpatch_home"></a>`ora_install::patch_home`

See the file "LICENSE" for the full license governing this code.

++--++

--++--

#### Examples

##### 

```puppet
bolt plan run ora_install::patch_home -t localhost patch_list='{"/u01/app/oracle/product/18.0.0.0/db_home2:30116795": {"source": "/nfs_share/software/p30116795_180000_Linux-x86-64.zip", "sub_patches": ["30112122","30113775"]}}'
```

#### Parameters

The following parameters are available in the `ora_install::patch_home` plan:

* [`dbserver`](#dbserver)
* [`install_group`](#install_group)
* [`os_user`](#os_user)
* [`source`](#source)
* [`patch_list`](#patch_list)
* [`tmp_dir`](#tmp_dir)
* [`format`](#format)

##### <a name="dbserver"></a>`dbserver`

Data type: `TargetSpec`

The target for this plan.

##### <a name="install_group"></a>`install_group`

Data type: `String[1]`

The os group to use for installation.

Default value: `'oinstall'`

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The user used for the specified installation.

Default value: `'oracle'`

##### <a name="source"></a>`source`

Data type: `Optional[String[1]]`

The source of the patch. Can be either an extracted folder or the raw zip file.

Default value: ``undef``

##### <a name="patch_list"></a>`patch_list`

Data type: `Hash`

List of patches to apply.

Options:

* **source** `String[1]`: Full path to the zipfile that contains the patch
* **sub_patches** `Array`: List of patch numbers that are part of the patchset

Default value: `{}`

##### <a name="tmp_dir"></a>`tmp_dir`

Data type: `Stdlib::Absolutepath`

Directory to use for temporary files.

Default value: `'/install'`

##### <a name="format"></a>`format`

Data type: `Optional[Enum['json','pretty']]`

Specify the format of the output, human readable (pretty) or not (json).

Default value: `'pretty'`

### <a name="ora_installswitch_home_and_apply_psu"></a>`ora_install::switch_home_and_apply_psu`

See the file "LICENSE" for the full license governing this code.

++--++

--++--

#### Examples

##### 

```puppet
bolt plan run ora_install::switch_home_and_apply_psu -t localhost sid=DB180 new_home=/u01/app/oracle/product/18.0.0.0/db_home2
```

#### Parameters

The following parameters are available in the `ora_install::switch_home_and_apply_psu` plan:

* [`dbserver`](#dbserver)
* [`sid`](#sid)
* [`new_home`](#new_home)
* [`format`](#format)
* [`verbose`](#verbose)

##### <a name="dbserver"></a>`dbserver`

Data type: `TargetSpec`

The target for this plan.

##### <a name="sid"></a>`sid`

Data type: `String[1]`

The SID of the database that should be switched.

##### <a name="new_home"></a>`new_home`

Data type: `Stdlib::Absolutepath`

The ORACLE_HOME where the database should be switched to.

##### <a name="format"></a>`format`

Data type: `Optional[Enum['json','pretty']]`

Specify the format of the output, human readable (pretty) or not (json).

Default value: `'pretty'`

##### <a name="verbose"></a>`verbose`

Data type: `Optional[Optional[Enum['debug', 'info', 'notice', 'warning', 'err', 'alert', 'emerg', 'crit']]]`

The level of verbosity to use.

Default value: `'info'`

### <a name="ora_installswitch_home_asm"></a>`ora_install::switch_home_asm`

See the file "LICENSE" for the full license governing this code.

++--++

--++--

#### Examples

##### 

```puppet
bolt plan run ora_install::switch_home_asm -t localhost new_home=/u01/app/grid/product/19.0.0.0/grid_home2
```

#### Parameters

The following parameters are available in the `ora_install::switch_home_asm` plan:

* [`dbserver`](#dbserver)
* [`new_home`](#new_home)
* [`format`](#format)
* [`verbose`](#verbose)

##### <a name="dbserver"></a>`dbserver`

Data type: `TargetSpec`

The target for this plan.

##### <a name="new_home"></a>`new_home`

Data type: `Stdlib::Absolutepath`

The ORACLE_HOME where the database should be switched to.

##### <a name="format"></a>`format`

Data type: `Optional[Enum['json','pretty']]`

Specify the format of the output, human readable (pretty) or not (json).

Default value: `'pretty'`

##### <a name="verbose"></a>`verbose`

Data type: `Optional[Optional[Enum['debug', 'info', 'notice', 'warning', 'err', 'alert', 'emerg', 'crit']]]`

The level of verbosity to use.

Default value: `'info'`

