#
# See the file "LICENSE" for the full license governing this code.
#
# ora_install_homes.rb
#
require 'easy_type/flexible_fact'
require_relative '../puppet_x/enterprisemodules/ora_install/facts'

# get inventory location
Facter.add('ora_install_inventory_loc') do
  extend PuppetX::EnterpriseModules::OraInstall::Facts
  setcode do
    get_orainst_loc
  end
end

EasyType::FlexibleFact.define(:ora_install_homes) do
  extend PuppetX::EnterpriseModules::OraInstall::Facts

  components get_homes(get_orainst_loc)

  part(:product_version) do |component|
    get_product_version(component)
  end

  part(:opatch_version) do |component|
    get_opatch_version(component)
  end

  part(:installed_patches) do |component|
    get_installed_patches(component)
  end

  part(:defined_sids) do |component|
    get_defined_sids(component)
  end

  part(:running_processes) do |component|
    get_running_processes(component)
  end
end