#
# See the file "LICENSE" for the full license governing this code.
#
#
# This function checks if the specified home, is the current home for the
# specified SID.
#
Puppet::Functions.create_function(:'ora_install::changed_oracle_home_for') do
  dispatch :changed_oracle_home_for do
    param 'String[1]', :sid
    param 'String[1]',   :oracle_home
    return_type 'Variant[Boolean, Undef]'
  end

  def changed_oracle_home_for(sid, home)
    oracle_homes = closure_scope['ora_install_homes'] || {'defined_sids' => {}}
    current_home = oracle_homes['defined_sids'].select {|home, attr| attr.include?(sid)}.keys.first
    current_home.nil? ? nil : current_home != home
  end
end
