#
# See the file "LICENSE" for the full license governing this code.
#
# Return a true or a false based on the fact if oracle exists
require 'puppet/util/log'

Puppet::Functions.create_function(:'ora_install::oracle_exists') do
  dispatch :oracle_exists do
    param 'String', :oracle_home
    return_type 'Boolean'
  end

  def oracle_exists(oracle_home)
    scope = closure_scope
    fact = scope['ora_install_homes']
    if fact && fact['product_version'][oracle_home]
      true
    else
      false
    end
  end
end
