#
# See the file "LICENSE" for the full license governing this code.
#
#
# This function checks if the specfied patches are installed.
# The patch list is an array and has the syntax
#
#    ['/oracle/home/dir:patchid']
#
# It will check all registered Oracle homes for the installed patches.
#
Puppet::Functions.create_function(:'ora_patches_installed') do
  dispatch :check_patch_list do
    param 'Array', :patch_list
    return_type 'Boolean'
  end

  def check_patch_list(patch_list)
    Puppet.warn_once('deprecations', 'ora_patches_installed',"Function 'ora_patches_installed' is deprecated. Please use 'ora_install::ora_patches_installed'.")
    call_function('ora_install::ora_patches_installed', patch_list)
  end
end
