#
# See the file "LICENSE" for the full license governing this code.
#
#
# This function parses a Hash of patches and looks for resources with
# sub_patches. If they are there, this function will translate it to the
# actual list of patches that need to be on the system.
#
Puppet::Functions.create_function(:'ora_physical_patches') do
  dispatch :physical_patches do
    param 'Hash', :patch_list
    return_type 'Array'
  end

  def physical_patches(patch_list)
    Puppet.warn_once('deprecations', 'ora_physical_patches',"Function 'ora_physical_patches' is deprecated. Please use 'ora_install::ora_physical_patches'.")
    call_function('ora_install::ora_physical_patches', patch_list)
  end
end
