#
# See the file "LICENSE" for the full license governing this code.
#
# Return a true or a false based on the fact if oracle exists
require 'puppet/util/log'

Puppet::Functions.create_function(:'oracle_exists') do
  dispatch :oracle_exists do
    param 'String', :oracle_home
    return_type 'Boolean'
  end

  def oracle_exists(oracle_home)
    Puppet.warn_once('deprecations', 'oracle_exists',"Function 'oracle_exists' is deprecated. Please use 'ora_install::oracle_exists'.")
    call_function('ora_install::oracle_exists', oracle_home)
  end

end
