#
# See the file "LICENSE" for the full license governing this code.
#
require 'easy_type'

Puppet::Type.type(:ora_opatch).provide(:auto, :parent => :base) do
  def self.instances
    []
  end

  def context
    "export ORACLE_HOME=#{oracle_product_home_dir}; cd #{oracle_product_home_dir}; "
  end

  def apply_patch(source_dir)
    ocmrf = resource.ocmrf_file_value.nil? ? '' : " -ocmrf #{resource.ocmrf_file_value}"
    opatch("auto #{source_dir} #{ocmrf} -oh #{oracle_product_home_dir}", {:os_user => 'root', :oracle_home => oracle_product_home_dir})
  end

  def remove_patch(source_dir)
    ocmrf = resource.ocmrf_file_value.nil? ? '' : " -ocmrf #{resource.ocmrf_file_value}"
    opatch("auto -rollback #{source_dir} #{ocmrf} -oh #{oracle_product_home_dir}", {:os_user => 'root', :oracle_home => oracle_product_home_dir})
  end
end
