#
# See the file "LICENSE" for the full license governing this code.
#
require 'easy_type'

Puppet::Type.type(:ora_opatch).provide(:opatchauto, :parent => :base) do
  desc 'Use the new Opatchauto utility'

  #
  # Regular provider gets all instances already
  #
  def self.instances
    []
  end

  def apply_patch(source_dir)
    ocmrf = resource.ocmrf_file_value.nil? ? '' : " -ocmrf #{resource.ocmrf_file_value}"
    opatchauto("apply #{source_dir} #{ocmrf} -oh #{oracle_product_home_dir}", {:os_user => 'root', :oracle_home => oracle_product_home_dir, :cwd => resource[:cwd]})
  end

  def remove_patch(source_dir)
    ocmrf = resource.ocmrf_file_value.nil? ? '' : " -ocmrf #{resource.ocmrf_file_value}"
    opatchauto("rollback #{source_dir} #{ocmrf} -oh #{oracle_product_home_dir}", {:os_user => 'root', :oracle_home => oracle_product_home_dir, :cwd => resource[:cwd]})
  end
end
