#
# See the file "LICENSE" for the full license governing this code.
#
require 'easy_type'

Puppet::Type.type(:ora_opatch).provide(:regular, :parent => :base) do
  include EasyType::Provider
  include PuppetX::EnterpriseModules::OraInstall::Commands

  desc 'Apply Oracle regular OPatches'

  #
  # This is bit of a hack. id is always root, but we need to declare a default provider
  #
  defaultfor :id => 'root'
  defaultfor :operatingsystem => :windows

  def apply_patch(source_dir)
    ocmrf = resource.ocmrf_file_value.nil? ? '' : " -ocmrf #{resource.ocmrf_file_value}"
    opatch("apply -silent #{ocmrf} -oh #{oracle_product_home_dir} #{source_dir} -local", {:os_user => os_user, :oracle_home => oracle_product_home_dir, :cwd => resource[:cwd]})
  end

  def remove_patch(source_dir)
    opatch("rollback -id #{patch_id} -silent -oh #{oracle_product_home_dir} -local", {:os_user => os_user, :oracle_home => oracle_product_home_dir, :cwd => resource[:cwd]})
  end
end
