#
# See the file "LICENSE" for the full license governing this code.
#
require 'puppet_x/enterprisemodules/ora_install/core'

module Puppet
  Type.newtype(:db_listener) do
    include EasyType

    def refresh
      Puppet.info 'db_listener refresh'
      provider.restart
    end

    def self.module_name; 'ora_install'; end
    desc 'control the oracle db listener state like running,stop,restart'

    parameter :name
    parameter :oracle_base_dir
    parameter :listener_name
    parameter :refresh_only

    property  :ensure
    property  :oracle_home_dir
    property  :os_user

  end
end
