newproperty(:ensure) do
  desc 'Whether to do something.'

  newvalue(:start, :event => :listener_running) do
    unless resource[:refreshonly] == :true
      provider.start
    end
  end

  newvalue(:stop, :event => :listener_stop) do
    unless resource[:refreshonly] == :true
      provider.stop
    end
  end

  aliasvalue(:running, :start)
  aliasvalue(:abort, :stop)

  def retrieve
    provider.ensure
  end

  def insync?(to)
    if resource[:refreshonly] == :true
      true
    else
      to == should
    end
  end

  def sync
   event = super()
   if property = @resource.property(:enable)
      val = property.retrieve
      property.sync unless property.safe_insync?(val)
    end
    event
  end
end
