#
# See the file "LICENSE" for the full license governing this code.
#
require 'easy_type/source_dir'

newparam(:source, :parent => EasyType::SourceDir) do
  # desc <<-EOT
  #   The source of the golden image. Can be either an extracted folder or the raw zip file.
  #
  #   The source of the file can also be a puppet url. In that case, the files is fetched from
  #   the Puppet server and used as the source for the opatch command.
  #
  # EOT

  defaultto ''
  auto_unpack true
  auto_uncompress true

  # Override extract dir to extract directly to Oracle home
  def extract_dir
    resource[:location]
  end

  isrequired
end
