# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#

newparam(:cwd) do
  include EasyType

  desc <<-DESC
    The default directory from where the patching will be run. If not specified, this will be the current
    directory. If the current directory is not writable, /tmp will be used.

        ora_opatch {...:
          ...
          cwd => '/oracle/home'
        }

  DESC

  data_type('Optional[String[1]]')
end
