#
# See the file "LICENSE" for the full license governing this code.
#
module PuppetX
  module EnterpriseModules
    module OraInstall
      # docs
      module Commands
        def self.included(parent)
          parent.extend(Commands)
        end

        [:opatch, :opatchauto].each do |command|
          file  = "puppet_x/enterprisemodules/ora_install/#{command}_command"
          klass = "#{command.to_s.capitalize}Command"
          require file

          module_eval(<<-END_RUBY, __FILE__, __LINE__)
            # @nodoc
            # @private
            def #{command}( arguments, options = {} )
              #{command} = PuppetX::EnterpriseModules::OraInstall::#{klass}.new(options)
              #{command}.execute(arguments, options)
            end
          END_RUBY
        end
      end
    end
  end
end
