#
# See the file "LICENSE" for the full license governing this code.
#
require 'puppet_x/enterprisemodules/ora_install/core'

module PuppetX
  module EnterpriseModules
    module OraInstall
      # docs
      class OpatchCommand < PuppetX::EnterpriseModules::OraInstall::Command
        def initialize(options = {})
          super(:opatch, options)
        end

        def execute(arguments, command_options)
          if Facter.value(:kernel) == 'windows'
            environment = {}
            oracle_home = command_options[:oracle_home]
            environment[:PATH] = "C:\\Windows\\system32;C:\\Windows;#{oracle_home}\\bin;#{oracle_home}\\OPatch"
            environment[:ORACLE_HOME] = oracle_home
            options = { :failonfail => true, :combine => true, :custom_environment => environment }
          else
            options = { :failonfail => true, :combine => true }
          end
          value = ''
          command = command_string(arguments, command_options)
          Puppet.debug "Executing #{@command} command: #{arguments} as #{os_user}"
          value = Puppet::Util::Execution.execute(command, options)
          raise 'Opatch contained an error' unless value =~ /OPatch completed|OPatch succeeded|opatch auto succeeded|opatchauto succeeded/

          value
        end
      end
    end
  end
end
