#
# See the file "LICENSE" for the full license governing this code.
#
require 'puppet_x/enterprisemodules/ora_install/core'

module PuppetX
  module EnterpriseModules
    module OraInstall
      # docs
      class OpatchautoCommand < PuppetX::EnterpriseModules::OraInstall::Command
        def initialize(options = {})
          super(:opatchauto, options)
        end

        def execute(arguments, command_options)
          options = { :failonfail => true, :combine => true }
          value = ''
          command = command_string(arguments, command_options)
          Puppet.debug "Executing #{@command} command: #{arguments} as #{os_user}"
          value = Puppet::Util::Execution.execute(command, options)
          # Add 2 minutes sleep because opatchauto doesn't always wait until everything is running (maybe only in =<12.2?)
          sleep 120
          raise 'Opatch contained an error' unless value =~ /OPatch completed|OPatch succeeded|opatch auto succeeded|opatchauto succeeded|OPatchAuto successful/
          value
        end
      end
    end
  end
end
