require 'pathname'
$LOAD_PATH.unshift(File.absolute_path("#{__dir__}/../.."))
$LOAD_PATH.unshift(File.absolute_path("#{__dir__}/../../../../ora_config/lib"))
$LOAD_PATH.unshift(File.absolute_path("#{__dir__}/../../../../easy_type/lib"))
require 'puppet_x/enterprisemodules/oracle/settings'
require 'win32/registry'

module PuppetX
  module EnterpriseModules
    module OraInstall
      # docs
      module WindowsCore
        include PuppetX::EnterpriseModules::Oracle::Settings
        include ::EasyType::Encryption
        include ::EasyType::Template

        def execute_sql(db, sql)
          # Execute
          @sid ||= db
          @os_user ||= configuration_value_for(@sid, 'os_user')
          @oracle_home ||= configuration_value_for(@sid, 'oracle_home')
          @os_user_pwd = decrypted_value(configuration_value_for(@sid, 'os_user_pwd'))
          options = { :failonfail => true, :combine => true }
          powershell_command = %(powershell -File "#{powershell_script(sql_script(sql))}")
          Puppet::Util::Execution.execute(powershell_command, options)
        end

        def sql_script(sql)
          # Generate sql script
          command_file = Tempfile.new(['command', '.sql'])
          ObjectSpace.undefine_finalizer(command_file)
          command = %(connect / as sysdba
                      #{sql})
          content = template('ora_install/ora_install/execute.sql.erb', binding)
          command_file.write(content)
          command_file.close
          command_file.path
        end

        def powershell_script(sql_script)
          # Generate powershell script
          powershell_file = Tempfile.new(['command', '.ps1'])
          ObjectSpace.undefine_finalizer(powershell_file)
          powershell_content = template('ora_install/ora_install/sqlplus_command.ps1.erb', binding)
          powershell_file.write(powershell_content)
          powershell_file.close
          powershell_file.path
        end
      end
    end
  end
end
