#
# ora_install::clear_caches
#
# @summary This class contains the puppet code that implements the default facter cache invainvalidationlidatin rules.
# Whenever a certain set of Puppet classes or defined types is applied, it will clear the facter caches for those facts that are implemented.
#
#
# See the file "LICENSE" for the full license governing this code.
#
class ora_install::clear_caches () {
  fact_cache { 'ora_install_homes.product_version':
    ensure      => absent,
    refreshonly => true,
  }
  Ora_install::Installdb<||>       ~> Fact_cache['ora_install_homes.product_version']
  Ora_install::Client<||>          ~> Fact_cache['ora_install_homes.product_version']
  Ora_install::Goldengate<||>      ~> Fact_cache['ora_install_homes.product_version']
  Ora_install::Installasm<||>      ~> Fact_cache['ora_install_homes.product_version']
  Ora_install::Installem<||>       ~> Fact_cache['ora_install_homes.product_version']
  Ora_install::Installem_agent<||> ~> Fact_cache['ora_install_homes.product_version']

  fact_cache { 'ora_install_homes.opatch_version':
    ensure      => absent,
    refreshonly => true,
  }
  Ora_install::Installdb<||>       ~> Fact_cache['ora_install_homes.opatch_version']
  Ora_install::Client<||>          ~> Fact_cache['ora_install_homes.opatch_version']
  Ora_install::Goldengate<||>      ~> Fact_cache['ora_install_homes.opatch_version']
  Ora_install::Installasm<||>      ~> Fact_cache['ora_install_homes.opatch_version']
  Ora_install::Installem<||>       ~> Fact_cache['ora_install_homes.opatch_version']
  Ora_install::Installem_agent<||> ~> Fact_cache['ora_install_homes.opatch_version']
  Ora_install::Opatchupgrade<||>   ~> Fact_cache['ora_install_homes.opatch_version']

  fact_cache { 'ora_install_homes.installed_patches':
    ensure      => absent,
    refreshonly => true,
  }
  Ora_install::Installdb<||>       ~> Fact_cache['ora_install_homes.installed_patches']

  if defined('Ora_opatch') {
    Ora_opatch<||>                   ~> Fact_cache['ora_install_homes.installed_patches']
  }

  Ora_install::Goldengate<||>      ~> Fact_cache['ora_install_homes.installed_patches']
  Ora_install::Installasm<||>      ~> Fact_cache['ora_install_homes.installed_patches']
  Ora_install::Installem<||>       ~> Fact_cache['ora_install_homes.installed_patches']
  Ora_install::Installem_agent<||> ~> Fact_cache['ora_install_homes.installed_patches']

  fact_cache { 'ora_install_homes.running_processes':
    ensure      => absent,
    refreshonly => true,
  }
  Ora_install::Installdb<||> ~> Fact_cache['ora_install_homes.running_processes']
  Ora_install::Database<||>  ~> Fact_cache['ora_install_homes.running_processes']
  Ora_install::Dbactions<||> ~> Fact_cache['ora_install_homes.running_processes']
  Db_control<||>             ~> Fact_cache['ora_install_homes.running_processes']

  if defined('Ora_database') {
    Ora_database<||> ~> Fact_cache['ora_install_homes.running_processes']
  }

  fact_cache { 'ora_install_homes.defined_sids':
    ensure      => absent,
    refreshonly => true,
  }
  Ora_install::Installdb<||> ~> Fact_cache['ora_install_homes.defined_sids']
  Ora_install::Database<||>  ~> Fact_cache['ora_install_homes.defined_sids']
  Ora_tab_entry<||>          ~> Fact_cache['ora_install_homes.defined_sids']

  if defined('Ora_database') {
    Ora_database<||> ~> Fact_cache['ora_install_homes.defined_sids']
  }

  fact_cache { 'ora_install_inventory_loc':
    ensure      => absent,
    refreshonly => true,
  }
  Ora_install::Installdb<||>  ~> Fact_cache['ora_install_inventory_loc']
  Ora_install::Installasm<||> ~> Fact_cache['ora_install_inventory_loc']
}
