#
# ora_install::utils::dborainst
#
# @summary Internal utility to create the required Oracle directories.
#
#
# @param [Stdlib::Absolutepath] ora_inventory_dir
#    The directory that contains the oracle inventory.
#    The default value is: `/oracle_base/oraInventory`
#
# @param [String[1]] os_group
#    The OS group to apply to the created directories.
#
# @param [String[1]] os_user
#    The OS user to apply to the created directories.
#
#
# See the file "LICENSE" for the full license governing this code.
#
define ora_install::utils::dborainst (
  Stdlib::Absolutepath $ora_inventory_dir = undef,
  String[1]            $os_group          = undef,
  String[1]            $os_user           = undef,
) {
  easy_type::debug_evaluation() # Show local variable on extended debug

  db_directory_structure { "Create oraInst.loc ${title}":
    ensure              => present,
    ora_inventory_dir   => $ora_inventory_dir,
    os_user             => $os_user,
    os_group            => $os_group,
    create_orainst_only => true,
  }
}
