#!/opt/puppetlabs/puppet/bin/ruby
require 'json'
require 'open3'
require 'puppet'
require 'time'

params = JSON.parse(STDIN.read)
#
# Use loadpath specfied in the params
#
$LOAD_PATH << "#{params['_installdir']}/easy_type/lib"
$LOAD_PATH << "#{params['_installdir']}/ora_install/lib"

require 'easy_type'
require 'puppet_x/enterprisemodules/ora_install/tasks'
extend ::PuppetX::EnterpriseModules::OraInstall::Tasks

sid           = params.fetch('sid') { default_database_sid}
action        = params.fetch('action')
listener_name = params.fetch('listener_name')
@verbose      = params.fetch('verbose') { 'info' }
@format       = params.fetch('format') { 'pretty' }
@starttime    = Time.now.iso8601
@message      = []
Puppet::Util::Log.level = @verbose

begin
  if action == 'stop'
    log_msg stop_listener(sid, listener_name)
  elsif action == 'start'
    log_msg start_listener(sid, listener_name)
  elsif action == 'restart'
    log_msg stop_listener(sid, listener_name)
    log_msg start_listener(sid, listener_name)
  end
  output_message = @message.join("\n")
  output(0, output_message)
rescue Puppet::Error => e
  error_output(1, e.message, "enterprisemodules-ora_install/task-error")
end
