#!/opt/puppetlabs/puppet/bin/ruby
require 'json'
require 'open3'
require 'puppet'
require 'time'

params = JSON.parse(STDIN.read)
#
# Use loadpath specfied in the params
#
$LOAD_PATH << "#{params['_installdir']}/easy_type/lib"
$LOAD_PATH << "#{params['_installdir']}/ora_install/lib"

require 'easy_type'
require 'puppet_x/enterprisemodules/ora_install/tasks'
extend ::PuppetX::EnterpriseModules::OraInstall::Tasks

sid        = params.fetch('sid') { default_database_sid }
type       = params.fetch('type') { 'normal' }
@verbose   = params.fetch('verbose') { 'info' }
@planned   = params.fetch('planned')
@starttime = Time.now.iso8601
Puppet::Util::Log.level = @verbose

begin
  result = shutdown(sid, type)
  if @planned
    output(0, result)
  else
    puts result
  end
rescue Puppet::Error => e
  error_output(1, e.message, "enterprisemodules-ora_install/task-error")
end
